import {
  DefaultBrand
} from "./chunk-EOXPQFQF.js";
import "./chunk-6P4Q5A35.js";
import "./chunk-YHBCGAQD.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-KAZHUE5U.js";
import "./chunk-RRTO23J6.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-IBWMO6UG.js";
import {
  TablePage
} from "./chunk-BOFJZWRL.js";
import "./chunk-33FVPXQF.js";
import "./chunk-3JQUPLLV.js";
import "./chunk-LC5NTBIM.js";
import "./chunk-VQLEOAO7.js";
import "./chunk-ACKAU7UB.js";
import "./chunk-LEBYUIHG.js";
import "./chunk-ILUJ2G4Q.js";
import "./chunk-T7CHIH4E.js";
import "./chunk-73PMFTGI.js";
import {
  browser_default
} from "./chunk-OBKOQLSR.js";
import "./chunk-O6PXCBWL.js";
import {
  ModelForm
} from "./chunk-AYF4HFW2.js";
import "./chunk-WUMYQQVB.js";
import {
  FlowsInstancesListDesignationEnum
} from "./chunk-JUOHD3PM.js";
import "./chunk-NRRZ6XDD.js";
import "./chunk-MXCYZZ7R.js";
import "./chunk-UX7TDHO2.js";
import "./chunk-LQRAB2DN.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-F4SCNWUD.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-O4CYWEUV.js";
import {
  TableColumn
} from "./chunk-KZUPUEAQ.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-KP2VLRW5.js";
import "./chunk-EXVQ6V2P.js";
import {
  CoreApi,
  DEFAULT_CONFIG,
  first,
  n,
  t
} from "./chunk-AMC4UCMS.js";
import {
  ke,
  msg
} from "./chunk-XFT4DB4U.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/brands/BrandForm.ts
var BrandForm = class extends ModelForm {
  loadInstance(pk) {
    return new CoreApi(DEFAULT_CONFIG).coreBrandsRetrieve({
      brandUuid: pk
    });
  }
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated brand.") : msg("Successfully created brand.");
  }
  async send(data) {
    if (this.instance?.brandUuid) {
      return new CoreApi(DEFAULT_CONFIG).coreBrandsUpdate({
        brandUuid: this.instance.brandUuid,
        brandRequest: data
      });
    } else {
      return new CoreApi(DEFAULT_CONFIG).coreBrandsCreate({
        brandRequest: data
      });
    }
  }
  renderForm() {
    return ke` <ak-form-element-horizontal
                label=${msg("Domain")}
                ?required=${true}
                name="domain"
            >
                <input
                    type="text"
                    value="${first(this.instance?.domain, window.location.host)}"
                    class="pf-c-form-control"
                    required
                />
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Matching is done based on domain suffix, so if you enter domain.tld, foo.domain.tld will still match."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal name="_default">
                <label class="pf-c-switch">
                    <input
                        class="pf-c-switch__input"
                        type="checkbox"
                        ?checked=${first(this.instance?._default, false)}
                    />
                    <span class="pf-c-switch__toggle">
                        <span class="pf-c-switch__toggle-icon">
                            <i class="fas fa-check" aria-hidden="true"></i>
                        </span>
                    </span>
                    <span class="pf-c-switch__label">${msg("Default")}</span>
                </label>
                <p class="pf-c-form__helper-text">
                    ${msg("Use this brand for each domain that doesn't have a dedicated brand.")}
                </p>
            </ak-form-element-horizontal>

            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Branding settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Title")}
                        ?required=${true}
                        name="brandingTitle"
                    >
                        <input
                            type="text"
                            value="${first(
      this.instance?.brandingTitle,
      DefaultBrand.brandingTitle
    )}"
                            class="pf-c-form-control"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg("Branding shown in page title and several other places.")}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Logo")}
                        ?required=${true}
                        name="brandingLogo"
                    >
                        <input
                            type="text"
                            value="${first(this.instance?.brandingLogo, DefaultBrand.brandingLogo)}"
                            class="pf-c-form-control"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg("Icon shown in sidebar/header and flow executor.")}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Favicon")}
                        ?required=${true}
                        name="brandingFavicon"
                    >
                        <input
                            type="text"
                            value="${first(
      this.instance?.brandingFavicon,
      DefaultBrand.brandingFavicon
    )}"
                            class="pf-c-form-control"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg("Icon shown in the browser tab.")}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>

            <ak-form-group>
                <span slot="header"> ${msg("External user settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Default application")}
                        name="defaultApplication"
                    >
                        <ak-search-select
                            blankable
                            .fetchObjects=${async (query) => {
      const args = {
        ordering: "name",
        superuserFullList: true
      };
      if (query !== void 0) {
        args.search = query;
      }
      const users = await new CoreApi(
        DEFAULT_CONFIG
      ).coreApplicationsList(args);
      return users.results;
    }}
                            .renderElement=${(item) => {
      return item.name;
    }}
                            .renderDescription=${(item) => {
      return ke`${item.slug}`;
    }}
                            .value=${(item) => {
      return item?.pk;
    }}
                            .selected=${(item) => {
      return item.pk === this.instance?.defaultApplication;
    }}
                        >
                        </ak-search-select>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "When configured, external users will automatically be redirected to this application when not attempting to access a different application"
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>

            <ak-form-group>
                <span slot="header"> ${msg("Default flows")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Authentication flow")}
                        name="flowAuthentication"
                    >
                        <ak-flow-search
                            flowType=${FlowsInstancesListDesignationEnum.Authentication}
                            .currentFlow=${this.instance?.flowAuthentication}
                        ></ak-flow-search>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Flow used to authenticate users. If left empty, the first applicable flow sorted by the slug is used."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Invalidation flow")}
                        name="flowInvalidation"
                    >
                        <ak-flow-search
                            flowType=${FlowsInstancesListDesignationEnum.Invalidation}
                            .currentFlow=${this.instance?.flowInvalidation}
                        ></ak-flow-search>

                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Flow used to logout. If left empty, the first applicable flow sorted by the slug is used."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal label=${msg("Recovery flow")} name="flowRecovery">
                        <ak-flow-search
                            flowType=${FlowsInstancesListDesignationEnum.Recovery}
                            .currentFlow=${this.instance?.flowRecovery}
                        ></ak-flow-search>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Unenrollment flow")}
                        name="flowUnenrollment"
                    >
                        <ak-flow-search
                            flowType=${FlowsInstancesListDesignationEnum.Unenrollment}
                            .currentFlow=${this.instance?.flowUnenrollment}
                        ></ak-flow-search>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "If set, users are able to unenroll themselves using this flow. If no flow is set, option is not shown."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("User settings flow")}
                        name="flowUserSettings"
                    >
                        <ak-flow-search
                            flowType=${FlowsInstancesListDesignationEnum.StageConfiguration}
                            .currentFlow=${this.instance?.flowUserSettings}
                        ></ak-flow-search>
                        <p class="pf-c-form__helper-text">
                            ${msg("If set, users are able to configure details of their profile.")}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Device code flow")}
                        name="flowDeviceCode"
                    >
                        <ak-flow-search
                            flowType=${FlowsInstancesListDesignationEnum.StageConfiguration}
                            .currentFlow=${this.instance?.flowDeviceCode}
                        ></ak-flow-search>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "If set, the OAuth Device Code profile can be used, and the selected flow will be used to enter the code."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>
            <ak-form-group>
                <span slot="header"> ${msg("Other global settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Web Certificate")}
                        name="webCertificate"
                    >
                        <ak-crypto-certificate-search
                            .certificate=${this.instance?.webCertificate}
                        ></ak-crypto-certificate-search>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal label=${msg("Attributes")} name="attributes">
                        <ak-codemirror
                            mode=${"yaml" /* YAML */}
                            value="${browser_default.stringify(first(this.instance?.attributes, {}))}"
                        >
                        </ak-codemirror>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Set custom attributes using YAML or JSON. Any attributes set here will be inherited by users, if the request is handled by this brand."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>`;
  }
};
BrandForm = __decorateClass([
  t("ak-brand-form")
], BrandForm);

// src/admin/brands/BrandListPage.ts
var BrandListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "domain";
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Brands");
  }
  pageDescription() {
    return msg("Configure visual settings and defaults for different domains.");
  }
  pageIcon() {
    return "pf-icon pf-icon-tenant";
  }
  async apiEndpoint() {
    return new CoreApi(DEFAULT_CONFIG).coreBrandsList(await this.defaultEndpointConfig());
  }
  columns() {
    return [
      new TableColumn(msg("Domain"), "domain"),
      new TableColumn(msg("Brand name"), "branding_title"),
      new TableColumn(msg("Default?"), "default"),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return ke`<ak-forms-delete-bulk
            objectLabel=${msg("Brand(s)")}
            .objects=${this.selectedElements}
            .metadata=${(item) => {
      return [{ key: msg("Domain"), value: item.domain }];
    }}
            .usedBy=${(item) => {
      return new CoreApi(DEFAULT_CONFIG).coreBrandsUsedByList({
        brandUuid: item.brandUuid
      });
    }}
            .delete=${(item) => {
      return new CoreApi(DEFAULT_CONFIG).coreBrandsDestroy({
        brandUuid: item.brandUuid
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    return [
      ke`${item.domain}`,
      ke`${item.brandingTitle}`,
      ke`<ak-status-label ?good=${item._default}></ak-status-label>`,
      ke`<ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg("Update Brand")} </span>
                    <ak-brand-form slot="form" .instancePk=${item.brandUuid}> </ak-brand-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>

                <ak-rbac-object-permission-modal
                    model=${RbacPermissionsAssignedByUsersListModelEnum.BrandsBrand}
                    objectPk=${item.brandUuid}
                >
                </ak-rbac-object-permission-modal>`
    ];
  }
  renderObjectCreate() {
    return ke`
            <ak-forms-modal>
                <span slot="submit"> ${msg("Create")} </span>
                <span slot="header"> ${msg("Create Brand")} </span>
                <ak-brand-form slot="form"> </ak-brand-form>
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Create")}</button>
            </ak-forms-modal>
        `;
  }
};
__decorateClass([
  n()
], BrandListPage.prototype, "order", 2);
BrandListPage = __decorateClass([
  t("ak-brand-list")
], BrandListPage);
export {
  BrandListPage
};
//# sourceMappingURL=BrandListPage-CUHGX4KN.js.map
