import "./chunk-GZBZR2MW.js";
import "./chunk-GXGHOOOB.js";
import {
  StagesApi
} from "./chunk-RGOIMBH4.js";
import "./chunk-UOXFC4Y2.js";
import "./chunk-WKHTTNZV.js";
import "./chunk-6P4Q5A35.js";
import "./chunk-HF2QJKVK.js";
import "./chunk-YHBCGAQD.js";
import "./chunk-KAZHUE5U.js";
import "./chunk-RRTO23J6.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-EGRHWZRV.js";
import "./chunk-TF7DSUKN.js";
import "./chunk-DBE2FDDV.js";
import {
  TablePage
} from "./chunk-BOFJZWRL.js";
import "./chunk-33FVPXQF.js";
import "./chunk-XOIODRMJ.js";
import "./chunk-3JQUPLLV.js";
import "./chunk-LC5NTBIM.js";
import "./chunk-VPULNDE4.js";
import "./chunk-PYFMVSMA.js";
import "./chunk-H6O674E7.js";
import "./chunk-LEBYUIHG.js";
import "./chunk-ILUJ2G4Q.js";
import "./chunk-7FLGQNJB.js";
import "./chunk-QSUYMBXD.js";
import "./chunk-T7CHIH4E.js";
import "./chunk-J6R4SJRI.js";
import "./chunk-W4FPXHKC.js";
import "./chunk-73PMFTGI.js";
import "./chunk-OBKOQLSR.js";
import "./chunk-O6PXCBWL.js";
import {
  ModelForm
} from "./chunk-AYF4HFW2.js";
import "./chunk-WUMYQQVB.js";
import "./chunk-CDWXKNE6.js";
import "./chunk-JDNU6LE7.js";
import "./chunk-GNYEGOJX.js";
import "./chunk-647BK4MP.js";
import "./chunk-BJ44WOI4.js";
import "./chunk-JUOHD3PM.js";
import "./chunk-NRRZ6XDD.js";
import "./chunk-MN6O4CLE.js";
import "./chunk-MXCYZZ7R.js";
import "./chunk-UX7TDHO2.js";
import "./chunk-LQRAB2DN.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-F4SCNWUD.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-VRCRCQLD.js";
import {
  showMessage
} from "./chunk-O4CYWEUV.js";
import {
  TableColumn
} from "./chunk-KZUPUEAQ.js";
import "./chunk-K3AR7TXW.js";
import {
  to
} from "./chunk-KP2VLRW5.js";
import "./chunk-EXVQ6V2P.js";
import {
  CoreApi,
  DEFAULT_CONFIG,
  n,
  t
} from "./chunk-AMC4UCMS.js";
import {
  D,
  ke,
  msg,
  str
} from "./chunk-XFT4DB4U.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/stages/authenticator_duo/DuoDeviceImportForm.ts
var DuoDeviceImportForm = class extends ModelForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorDuoRetrieve({
      stageUuid: pk
    });
  }
  getSuccessMessage() {
    return msg("Successfully imported device.");
  }
  async send(data) {
    const importData = data;
    return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorDuoImportDeviceManualCreate({
      stageUuid: this.instance?.pk || "",
      authenticatorDuoStageManualDeviceImportRequest: importData
    });
  }
  renderForm() {
    return ke` ${this.instance?.adminIntegrationKey !== "" ? this.renderFormAutomatic() : ke``}
        ${this.renderFormManual()}`;
  }
  renderFormManual() {
    return ke`<ak-form-element-horizontal
                label=${msg("User")}
                ?required=${true}
                name="username"
            >
                <ak-search-select
                    .fetchObjects=${async (query) => {
      const args = {
        ordering: "username"
      };
      if (query !== void 0) {
        args.search = query;
      }
      const users = await new CoreApi(DEFAULT_CONFIG).coreUsersList(args);
      return users.results;
    }}
                    .renderElement=${(user) => {
      return user.username;
    }}
                    .renderDescription=${(user) => {
      return ke`${user.name}`;
    }}
                    .value=${(user) => {
      return user?.username;
    }}
                >
                </ak-search-select>

                <p class="pf-c-form__helper-text">
                    ${msg("The user in authentik this device will be assigned to.")}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Duo User ID")}
                ?required=${true}
                name="duoUserId"
            >
                <input type="text" class="pf-c-form-control" required />
                <p class="pf-c-form__helper-text">
                    ${msg("The user ID in Duo, can be found in the URL after clicking on a user.")}
                </p>
            </ak-form-element-horizontal>`;
  }
  renderFormAutomatic() {
    return ke`
            <ak-form-element-horizontal label=${msg("Automatic import")}>
                <ak-action-button
                    class="pf-m-primary"
                    .apiRequest=${() => {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorDuoImportDevicesAutomaticCreate({
        stageUuid: this.instance?.pk || ""
      }).then((res) => {
        showMessage({
          level: "info" /* info */,
          message: msg(str`Successfully imported ${res.count} devices.`)
        });
        const modal = this.parentElement;
        modal.open = false;
      });
    }}
                >
                    ${msg("Start automatic import")}
                </ak-action-button>
            </ak-form-element-horizontal>
            <ak-divider>${msg("Or manually import")}</ak-divider>
            <br />
        `;
  }
};
DuoDeviceImportForm = __decorateClass([
  t("ak-stage-authenticator-duo-device-import-form")
], DuoDeviceImportForm);

// src/admin/stages/StageListPage.ts
var StageListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  pageTitle() {
    return msg("Stages");
  }
  pageDescription() {
    return msg(
      "Stages are single steps of a Flow that a user is guided through. A stage can only be executed from within a flow."
    );
  }
  pageIcon() {
    return "pf-icon pf-icon-plugged";
  }
  searchEnabled() {
    return true;
  }
  async apiEndpoint() {
    return new StagesApi(DEFAULT_CONFIG).stagesAllList(await this.defaultEndpointConfig());
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Flows")),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return ke`<ak-forms-delete-bulk
            objectLabel=${msg("Stage(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new StagesApi(DEFAULT_CONFIG).stagesAllUsedByList({
        stageUuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new StagesApi(DEFAULT_CONFIG).stagesAllDestroy({
        stageUuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  renderStageActions(stage) {
    return stage.component === "ak-stage-authenticator-duo-form" ? ke`<ak-forms-modal>
                  <span slot="submit">${msg("Import")}</span>
                  <span slot="header">${msg("Import Duo device")}</span>
                  <ak-stage-authenticator-duo-device-import-form
                      slot="form"
                      .instancePk=${stage.pk}
                  >
                  </ak-stage-authenticator-duo-device-import-form>
                  <button slot="trigger" class="pf-c-button pf-m-plain">
                      <pf-tooltip position="top" content=${msg("Import devices")}>
                          <i class="fas fa-file-import" aria-hidden="true"></i>
                      </pf-tooltip>
                  </button>
              </ak-forms-modal>` : D;
  }
  row(item) {
    return [
      ke`<div>${item.name}</div>
                <small>${item.verboseName}</small>`,
      ke`<ul class="pf-c-list">
                ${item.flowSet?.map((flow) => {
        return ke`<li>
                        <a href="#/flow/flows/${flow.slug}">
                            <code>${flow.slug}</code>
                        </a>
                    </li>`;
      })}
            </ul>`,
      ke`<ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg(str`Update ${item.verboseName}`)} </span>
                    <ak-proxy-form
                        slot="form"
                        .args=${{
        instancePk: item.pk
      }}
                        type=${to(item.component)}
                    >
                    </ak-proxy-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>
                <ak-rbac-object-permission-modal model=${item.metaModelName} objectPk=${item.pk}>
                </ak-rbac-object-permission-modal>
                ${this.renderStageActions(item)}`
    ];
  }
  renderObjectCreate() {
    return ke`<ak-stage-wizard></ak-stage-wizard> `;
  }
};
__decorateClass([
  n()
], StageListPage.prototype, "order", 2);
StageListPage = __decorateClass([
  t("ak-stage-list")
], StageListPage);
export {
  StageListPage
};
//# sourceMappingURL=StageListPage-AUTLGJ2I.js.map
