import {
  BaseAPI,
  JSONApiResponse,
  PaginationFromJSON,
  RequiredError,
  TypeCreateFromJSON,
  UsedByFromJSON,
  VoidApiResponse,
  exists
} from "./chunk-AMC4UCMS.js";

// node_modules/@goauthentik/api/dist/esm/models/GoogleWorkspaceProviderMapping.js
function GoogleWorkspaceProviderMappingFromJSON(json) {
  return GoogleWorkspaceProviderMappingFromJSONTyped(json, false);
}
function GoogleWorkspaceProviderMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/GoogleWorkspaceProviderMappingRequest.js
function GoogleWorkspaceProviderMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/KerberosSourcePropertyMapping.js
function KerberosSourcePropertyMappingFromJSON(json) {
  return KerberosSourcePropertyMappingFromJSONTyped(json, false);
}
function KerberosSourcePropertyMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/KerberosSourcePropertyMappingRequest.js
function KerberosSourcePropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/LDAPSourcePropertyMapping.js
function LDAPSourcePropertyMappingFromJSON(json) {
  return LDAPSourcePropertyMappingFromJSONTyped(json, false);
}
function LDAPSourcePropertyMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/LDAPSourcePropertyMappingRequest.js
function LDAPSourcePropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/MicrosoftEntraProviderMapping.js
function MicrosoftEntraProviderMappingFromJSON(json) {
  return MicrosoftEntraProviderMappingFromJSONTyped(json, false);
}
function MicrosoftEntraProviderMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/MicrosoftEntraProviderMappingRequest.js
function MicrosoftEntraProviderMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/NotificationWebhookMapping.js
function NotificationWebhookMappingFromJSON(json) {
  return NotificationWebhookMappingFromJSONTyped(json, false);
}
function NotificationWebhookMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "expression": json["expression"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/NotificationWebhookMappingRequest.js
function NotificationWebhookMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/OAuthSourcePropertyMapping.js
function OAuthSourcePropertyMappingFromJSON(json) {
  return OAuthSourcePropertyMappingFromJSONTyped(json, false);
}
function OAuthSourcePropertyMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/OAuthSourcePropertyMappingRequest.js
function OAuthSourcePropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedGoogleWorkspaceProviderMappingList.js
function PaginatedGoogleWorkspaceProviderMappingListFromJSON(json) {
  return PaginatedGoogleWorkspaceProviderMappingListFromJSONTyped(json, false);
}
function PaginatedGoogleWorkspaceProviderMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(GoogleWorkspaceProviderMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedKerberosSourcePropertyMappingList.js
function PaginatedKerberosSourcePropertyMappingListFromJSON(json) {
  return PaginatedKerberosSourcePropertyMappingListFromJSONTyped(json, false);
}
function PaginatedKerberosSourcePropertyMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(KerberosSourcePropertyMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedLDAPSourcePropertyMappingList.js
function PaginatedLDAPSourcePropertyMappingListFromJSON(json) {
  return PaginatedLDAPSourcePropertyMappingListFromJSONTyped(json, false);
}
function PaginatedLDAPSourcePropertyMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(LDAPSourcePropertyMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedMicrosoftEntraProviderMappingList.js
function PaginatedMicrosoftEntraProviderMappingListFromJSON(json) {
  return PaginatedMicrosoftEntraProviderMappingListFromJSONTyped(json, false);
}
function PaginatedMicrosoftEntraProviderMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(MicrosoftEntraProviderMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedNotificationWebhookMappingList.js
function PaginatedNotificationWebhookMappingListFromJSON(json) {
  return PaginatedNotificationWebhookMappingListFromJSONTyped(json, false);
}
function PaginatedNotificationWebhookMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(NotificationWebhookMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedOAuthSourcePropertyMappingList.js
function PaginatedOAuthSourcePropertyMappingListFromJSON(json) {
  return PaginatedOAuthSourcePropertyMappingListFromJSONTyped(json, false);
}
function PaginatedOAuthSourcePropertyMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(OAuthSourcePropertyMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PlexSourcePropertyMapping.js
function PlexSourcePropertyMappingFromJSON(json) {
  return PlexSourcePropertyMappingFromJSONTyped(json, false);
}
function PlexSourcePropertyMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPlexSourcePropertyMappingList.js
function PaginatedPlexSourcePropertyMappingListFromJSON(json) {
  return PaginatedPlexSourcePropertyMappingListFromJSONTyped(json, false);
}
function PaginatedPlexSourcePropertyMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PlexSourcePropertyMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PropertyMapping.js
function PropertyMappingFromJSON(json) {
  return PropertyMappingFromJSONTyped(json, false);
}
function PropertyMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPropertyMappingList.js
function PaginatedPropertyMappingListFromJSON(json) {
  return PaginatedPropertyMappingListFromJSONTyped(json, false);
}
function PaginatedPropertyMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PropertyMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/RACPropertyMapping.js
function RACPropertyMappingFromJSON(json) {
  return RACPropertyMappingFromJSONTyped(json, false);
}
function RACPropertyMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": !exists(json, "expression") ? void 0 : json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "staticSettings": json["static_settings"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedRACPropertyMappingList.js
function PaginatedRACPropertyMappingListFromJSON(json) {
  return PaginatedRACPropertyMappingListFromJSONTyped(json, false);
}
function PaginatedRACPropertyMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(RACPropertyMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/RadiusProviderPropertyMapping.js
function RadiusProviderPropertyMappingFromJSON(json) {
  return RadiusProviderPropertyMappingFromJSONTyped(json, false);
}
function RadiusProviderPropertyMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedRadiusProviderPropertyMappingList.js
function PaginatedRadiusProviderPropertyMappingListFromJSON(json) {
  return PaginatedRadiusProviderPropertyMappingListFromJSONTyped(json, false);
}
function PaginatedRadiusProviderPropertyMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(RadiusProviderPropertyMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SAMLPropertyMapping.js
function SAMLPropertyMappingFromJSON(json) {
  return SAMLPropertyMappingFromJSONTyped(json, false);
}
function SAMLPropertyMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "samlName": json["saml_name"],
    "friendlyName": !exists(json, "friendly_name") ? void 0 : json["friendly_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSAMLPropertyMappingList.js
function PaginatedSAMLPropertyMappingListFromJSON(json) {
  return PaginatedSAMLPropertyMappingListFromJSONTyped(json, false);
}
function PaginatedSAMLPropertyMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SAMLPropertyMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SAMLSourcePropertyMapping.js
function SAMLSourcePropertyMappingFromJSON(json) {
  return SAMLSourcePropertyMappingFromJSONTyped(json, false);
}
function SAMLSourcePropertyMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSAMLSourcePropertyMappingList.js
function PaginatedSAMLSourcePropertyMappingListFromJSON(json) {
  return PaginatedSAMLSourcePropertyMappingListFromJSONTyped(json, false);
}
function PaginatedSAMLSourcePropertyMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SAMLSourcePropertyMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMMapping.js
function SCIMMappingFromJSON(json) {
  return SCIMMappingFromJSONTyped(json, false);
}
function SCIMMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSCIMMappingList.js
function PaginatedSCIMMappingListFromJSON(json) {
  return PaginatedSCIMMappingListFromJSONTyped(json, false);
}
function PaginatedSCIMMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SCIMMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMSourcePropertyMapping.js
function SCIMSourcePropertyMappingFromJSON(json) {
  return SCIMSourcePropertyMappingFromJSONTyped(json, false);
}
function SCIMSourcePropertyMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSCIMSourcePropertyMappingList.js
function PaginatedSCIMSourcePropertyMappingListFromJSON(json) {
  return PaginatedSCIMSourcePropertyMappingListFromJSONTyped(json, false);
}
function PaginatedSCIMSourcePropertyMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SCIMSourcePropertyMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ScopeMapping.js
function ScopeMappingFromJSON(json) {
  return ScopeMappingFromJSONTyped(json, false);
}
function ScopeMappingFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "managed": !exists(json, "managed") ? void 0 : json["managed"],
    "name": json["name"],
    "expression": json["expression"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "scopeName": json["scope_name"],
    "description": !exists(json, "description") ? void 0 : json["description"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedScopeMappingList.js
function PaginatedScopeMappingListFromJSON(json) {
  return PaginatedScopeMappingListFromJSONTyped(json, false);
}
function PaginatedScopeMappingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ScopeMappingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedGoogleWorkspaceProviderMappingRequest.js
function PatchedGoogleWorkspaceProviderMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedKerberosSourcePropertyMappingRequest.js
function PatchedKerberosSourcePropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedLDAPSourcePropertyMappingRequest.js
function PatchedLDAPSourcePropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedMicrosoftEntraProviderMappingRequest.js
function PatchedMicrosoftEntraProviderMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedNotificationWebhookMappingRequest.js
function PatchedNotificationWebhookMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedOAuthSourcePropertyMappingRequest.js
function PatchedOAuthSourcePropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedPlexSourcePropertyMappingRequest.js
function PatchedPlexSourcePropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedRACPropertyMappingRequest.js
function PatchedRACPropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression,
    "static_settings": value.staticSettings
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedRadiusProviderPropertyMappingRequest.js
function PatchedRadiusProviderPropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedSAMLPropertyMappingRequest.js
function PatchedSAMLPropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression,
    "saml_name": value.samlName,
    "friendly_name": value.friendlyName
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedSAMLSourcePropertyMappingRequest.js
function PatchedSAMLSourcePropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedSCIMMappingRequest.js
function PatchedSCIMMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedSCIMSourcePropertyMappingRequest.js
function PatchedSCIMSourcePropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedScopeMappingRequest.js
function PatchedScopeMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression,
    "scope_name": value.scopeName,
    "description": value.description
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PlexSourcePropertyMappingRequest.js
function PlexSourcePropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PropertyMappingTestRequest.js
function PropertyMappingTestRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "user": value.user,
    "context": value.context,
    "group": value.group
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PropertyMappingTestResult.js
function PropertyMappingTestResultFromJSON(json) {
  return PropertyMappingTestResultFromJSONTyped(json, false);
}
function PropertyMappingTestResultFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "result": json["result"],
    "successful": json["successful"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/RACPropertyMappingRequest.js
function RACPropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression,
    "static_settings": value.staticSettings
  };
}

// node_modules/@goauthentik/api/dist/esm/models/RadiusProviderPropertyMappingRequest.js
function RadiusProviderPropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SAMLPropertyMappingRequest.js
function SAMLPropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression,
    "saml_name": value.samlName,
    "friendly_name": value.friendlyName
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SAMLSourcePropertyMappingRequest.js
function SAMLSourcePropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMMappingRequest.js
function SCIMMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMSourcePropertyMappingRequest.js
function SCIMSourcePropertyMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ScopeMappingRequest.js
function ScopeMappingRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "managed": value.managed,
    "name": value.name,
    "expression": value.expression,
    "scope_name": value.scopeName,
    "description": value.description
  };
}

// node_modules/@goauthentik/api/dist/esm/apis/PropertymappingsApi.js
var __awaiter = function(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var PropertymappingsApi = class extends BaseAPI {
  /**
   * PropertyMapping Viewset
   */
  propertymappingsAllDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsAllDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/all/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * PropertyMapping Viewset
   */
  propertymappingsAllDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsAllDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * PropertyMapping Viewset
   */
  propertymappingsAllListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.managedIsnull !== void 0) {
        queryParameters["managed__isnull"] = requestParameters.managedIsnull;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/all/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPropertyMappingListFromJSON(jsonValue));
    });
  }
  /**
   * PropertyMapping Viewset
   */
  propertymappingsAllList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsAllListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PropertyMapping Viewset
   */
  propertymappingsAllRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsAllRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/all/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * PropertyMapping Viewset
   */
  propertymappingsAllRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsAllRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Test Property Mapping
   */
  propertymappingsAllTestCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsAllTestCreate.");
      }
      const queryParameters = {};
      if (requestParameters.formatResult !== void 0) {
        queryParameters["format_result"] = requestParameters.formatResult;
      }
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/all/{pm_uuid}/test/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PropertyMappingTestRequestToJSON(requestParameters.propertyMappingTestRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PropertyMappingTestResultFromJSON(jsonValue));
    });
  }
  /**
   * Test Property Mapping
   */
  propertymappingsAllTestCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsAllTestCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get all creatable types
   */
  propertymappingsAllTypesListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/all/types/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(TypeCreateFromJSON));
    });
  }
  /**
   * Get all creatable types
   */
  propertymappingsAllTypesList(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsAllTypesListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsAllUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsAllUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/all/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsAllUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsAllUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.notificationWebhookMappingRequest === null || requestParameters.notificationWebhookMappingRequest === void 0) {
        throw new RequiredError("notificationWebhookMappingRequest", "Required parameter requestParameters.notificationWebhookMappingRequest was null or undefined when calling propertymappingsNotificationCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/notification/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: NotificationWebhookMappingRequestToJSON(requestParameters.notificationWebhookMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationWebhookMappingFromJSON(jsonValue));
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsNotificationCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsNotificationDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/notification/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsNotificationDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/notification/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedNotificationWebhookMappingListFromJSON(jsonValue));
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsNotificationListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsNotificationPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/notification/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedNotificationWebhookMappingRequestToJSON(requestParameters.patchedNotificationWebhookMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationWebhookMappingFromJSON(jsonValue));
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsNotificationPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsNotificationRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/notification/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationWebhookMappingFromJSON(jsonValue));
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsNotificationRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsNotificationUpdate.");
      }
      if (requestParameters.notificationWebhookMappingRequest === null || requestParameters.notificationWebhookMappingRequest === void 0) {
        throw new RequiredError("notificationWebhookMappingRequest", "Required parameter requestParameters.notificationWebhookMappingRequest was null or undefined when calling propertymappingsNotificationUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/notification/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: NotificationWebhookMappingRequestToJSON(requestParameters.notificationWebhookMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationWebhookMappingFromJSON(jsonValue));
    });
  }
  /**
   * NotificationWebhookMapping Viewset
   */
  propertymappingsNotificationUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsNotificationUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsNotificationUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsNotificationUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/notification/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsNotificationUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsNotificationUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GoogleWorkspaceProviderMapping Viewset
   */
  propertymappingsProviderGoogleWorkspaceCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.googleWorkspaceProviderMappingRequest === null || requestParameters.googleWorkspaceProviderMappingRequest === void 0) {
        throw new RequiredError("googleWorkspaceProviderMappingRequest", "Required parameter requestParameters.googleWorkspaceProviderMappingRequest was null or undefined when calling propertymappingsProviderGoogleWorkspaceCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/google_workspace/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: GoogleWorkspaceProviderMappingRequestToJSON(requestParameters.googleWorkspaceProviderMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => GoogleWorkspaceProviderMappingFromJSON(jsonValue));
    });
  }
  /**
   * GoogleWorkspaceProviderMapping Viewset
   */
  propertymappingsProviderGoogleWorkspaceCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderGoogleWorkspaceCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GoogleWorkspaceProviderMapping Viewset
   */
  propertymappingsProviderGoogleWorkspaceDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderGoogleWorkspaceDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/google_workspace/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * GoogleWorkspaceProviderMapping Viewset
   */
  propertymappingsProviderGoogleWorkspaceDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsProviderGoogleWorkspaceDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * GoogleWorkspaceProviderMapping Viewset
   */
  propertymappingsProviderGoogleWorkspaceListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.expression !== void 0) {
        queryParameters["expression"] = requestParameters.expression;
      }
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.pmUuid !== void 0) {
        queryParameters["pm_uuid"] = requestParameters.pmUuid;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/google_workspace/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedGoogleWorkspaceProviderMappingListFromJSON(jsonValue));
    });
  }
  /**
   * GoogleWorkspaceProviderMapping Viewset
   */
  propertymappingsProviderGoogleWorkspaceList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderGoogleWorkspaceListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GoogleWorkspaceProviderMapping Viewset
   */
  propertymappingsProviderGoogleWorkspacePartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderGoogleWorkspacePartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/google_workspace/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedGoogleWorkspaceProviderMappingRequestToJSON(requestParameters.patchedGoogleWorkspaceProviderMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => GoogleWorkspaceProviderMappingFromJSON(jsonValue));
    });
  }
  /**
   * GoogleWorkspaceProviderMapping Viewset
   */
  propertymappingsProviderGoogleWorkspacePartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderGoogleWorkspacePartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GoogleWorkspaceProviderMapping Viewset
   */
  propertymappingsProviderGoogleWorkspaceRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderGoogleWorkspaceRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/google_workspace/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => GoogleWorkspaceProviderMappingFromJSON(jsonValue));
    });
  }
  /**
   * GoogleWorkspaceProviderMapping Viewset
   */
  propertymappingsProviderGoogleWorkspaceRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderGoogleWorkspaceRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GoogleWorkspaceProviderMapping Viewset
   */
  propertymappingsProviderGoogleWorkspaceUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderGoogleWorkspaceUpdate.");
      }
      if (requestParameters.googleWorkspaceProviderMappingRequest === null || requestParameters.googleWorkspaceProviderMappingRequest === void 0) {
        throw new RequiredError("googleWorkspaceProviderMappingRequest", "Required parameter requestParameters.googleWorkspaceProviderMappingRequest was null or undefined when calling propertymappingsProviderGoogleWorkspaceUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/google_workspace/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: GoogleWorkspaceProviderMappingRequestToJSON(requestParameters.googleWorkspaceProviderMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => GoogleWorkspaceProviderMappingFromJSON(jsonValue));
    });
  }
  /**
   * GoogleWorkspaceProviderMapping Viewset
   */
  propertymappingsProviderGoogleWorkspaceUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderGoogleWorkspaceUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsProviderGoogleWorkspaceUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderGoogleWorkspaceUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/google_workspace/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsProviderGoogleWorkspaceUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderGoogleWorkspaceUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * MicrosoftEntraProviderMapping Viewset
   */
  propertymappingsProviderMicrosoftEntraCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.microsoftEntraProviderMappingRequest === null || requestParameters.microsoftEntraProviderMappingRequest === void 0) {
        throw new RequiredError("microsoftEntraProviderMappingRequest", "Required parameter requestParameters.microsoftEntraProviderMappingRequest was null or undefined when calling propertymappingsProviderMicrosoftEntraCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/microsoft_entra/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: MicrosoftEntraProviderMappingRequestToJSON(requestParameters.microsoftEntraProviderMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => MicrosoftEntraProviderMappingFromJSON(jsonValue));
    });
  }
  /**
   * MicrosoftEntraProviderMapping Viewset
   */
  propertymappingsProviderMicrosoftEntraCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderMicrosoftEntraCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * MicrosoftEntraProviderMapping Viewset
   */
  propertymappingsProviderMicrosoftEntraDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderMicrosoftEntraDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/microsoft_entra/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * MicrosoftEntraProviderMapping Viewset
   */
  propertymappingsProviderMicrosoftEntraDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsProviderMicrosoftEntraDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * MicrosoftEntraProviderMapping Viewset
   */
  propertymappingsProviderMicrosoftEntraListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.expression !== void 0) {
        queryParameters["expression"] = requestParameters.expression;
      }
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.pmUuid !== void 0) {
        queryParameters["pm_uuid"] = requestParameters.pmUuid;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/microsoft_entra/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedMicrosoftEntraProviderMappingListFromJSON(jsonValue));
    });
  }
  /**
   * MicrosoftEntraProviderMapping Viewset
   */
  propertymappingsProviderMicrosoftEntraList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderMicrosoftEntraListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * MicrosoftEntraProviderMapping Viewset
   */
  propertymappingsProviderMicrosoftEntraPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderMicrosoftEntraPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/microsoft_entra/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedMicrosoftEntraProviderMappingRequestToJSON(requestParameters.patchedMicrosoftEntraProviderMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => MicrosoftEntraProviderMappingFromJSON(jsonValue));
    });
  }
  /**
   * MicrosoftEntraProviderMapping Viewset
   */
  propertymappingsProviderMicrosoftEntraPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderMicrosoftEntraPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * MicrosoftEntraProviderMapping Viewset
   */
  propertymappingsProviderMicrosoftEntraRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderMicrosoftEntraRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/microsoft_entra/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => MicrosoftEntraProviderMappingFromJSON(jsonValue));
    });
  }
  /**
   * MicrosoftEntraProviderMapping Viewset
   */
  propertymappingsProviderMicrosoftEntraRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderMicrosoftEntraRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * MicrosoftEntraProviderMapping Viewset
   */
  propertymappingsProviderMicrosoftEntraUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderMicrosoftEntraUpdate.");
      }
      if (requestParameters.microsoftEntraProviderMappingRequest === null || requestParameters.microsoftEntraProviderMappingRequest === void 0) {
        throw new RequiredError("microsoftEntraProviderMappingRequest", "Required parameter requestParameters.microsoftEntraProviderMappingRequest was null or undefined when calling propertymappingsProviderMicrosoftEntraUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/microsoft_entra/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: MicrosoftEntraProviderMappingRequestToJSON(requestParameters.microsoftEntraProviderMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => MicrosoftEntraProviderMappingFromJSON(jsonValue));
    });
  }
  /**
   * MicrosoftEntraProviderMapping Viewset
   */
  propertymappingsProviderMicrosoftEntraUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderMicrosoftEntraUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsProviderMicrosoftEntraUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderMicrosoftEntraUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/microsoft_entra/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsProviderMicrosoftEntraUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderMicrosoftEntraUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsProviderRacCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.rACPropertyMappingRequest === null || requestParameters.rACPropertyMappingRequest === void 0) {
        throw new RequiredError("rACPropertyMappingRequest", "Required parameter requestParameters.rACPropertyMappingRequest was null or undefined when calling propertymappingsProviderRacCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/rac/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: RACPropertyMappingRequestToJSON(requestParameters.rACPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RACPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsProviderRacCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderRacCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsProviderRacDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderRacDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/rac/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsProviderRacDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsProviderRacDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsProviderRacListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/rac/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedRACPropertyMappingListFromJSON(jsonValue));
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsProviderRacList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderRacListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsProviderRacPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderRacPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/rac/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedRACPropertyMappingRequestToJSON(requestParameters.patchedRACPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RACPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsProviderRacPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderRacPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsProviderRacRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderRacRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/rac/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RACPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsProviderRacRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderRacRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsProviderRacUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderRacUpdate.");
      }
      if (requestParameters.rACPropertyMappingRequest === null || requestParameters.rACPropertyMappingRequest === void 0) {
        throw new RequiredError("rACPropertyMappingRequest", "Required parameter requestParameters.rACPropertyMappingRequest was null or undefined when calling propertymappingsProviderRacUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/rac/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: RACPropertyMappingRequestToJSON(requestParameters.rACPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RACPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * RACPropertyMapping Viewset
   */
  propertymappingsProviderRacUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderRacUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsProviderRacUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderRacUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/rac/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsProviderRacUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderRacUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RadiusProviderPropertyMapping Viewset
   */
  propertymappingsProviderRadiusCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.radiusProviderPropertyMappingRequest === null || requestParameters.radiusProviderPropertyMappingRequest === void 0) {
        throw new RequiredError("radiusProviderPropertyMappingRequest", "Required parameter requestParameters.radiusProviderPropertyMappingRequest was null or undefined when calling propertymappingsProviderRadiusCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/radius/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: RadiusProviderPropertyMappingRequestToJSON(requestParameters.radiusProviderPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RadiusProviderPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * RadiusProviderPropertyMapping Viewset
   */
  propertymappingsProviderRadiusCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderRadiusCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RadiusProviderPropertyMapping Viewset
   */
  propertymappingsProviderRadiusDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderRadiusDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/radius/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * RadiusProviderPropertyMapping Viewset
   */
  propertymappingsProviderRadiusDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsProviderRadiusDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * RadiusProviderPropertyMapping Viewset
   */
  propertymappingsProviderRadiusListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.managedIsnull !== void 0) {
        queryParameters["managed__isnull"] = requestParameters.managedIsnull;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/radius/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedRadiusProviderPropertyMappingListFromJSON(jsonValue));
    });
  }
  /**
   * RadiusProviderPropertyMapping Viewset
   */
  propertymappingsProviderRadiusList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderRadiusListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RadiusProviderPropertyMapping Viewset
   */
  propertymappingsProviderRadiusPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderRadiusPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/radius/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedRadiusProviderPropertyMappingRequestToJSON(requestParameters.patchedRadiusProviderPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RadiusProviderPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * RadiusProviderPropertyMapping Viewset
   */
  propertymappingsProviderRadiusPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderRadiusPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RadiusProviderPropertyMapping Viewset
   */
  propertymappingsProviderRadiusRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderRadiusRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/radius/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RadiusProviderPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * RadiusProviderPropertyMapping Viewset
   */
  propertymappingsProviderRadiusRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderRadiusRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RadiusProviderPropertyMapping Viewset
   */
  propertymappingsProviderRadiusUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderRadiusUpdate.");
      }
      if (requestParameters.radiusProviderPropertyMappingRequest === null || requestParameters.radiusProviderPropertyMappingRequest === void 0) {
        throw new RequiredError("radiusProviderPropertyMappingRequest", "Required parameter requestParameters.radiusProviderPropertyMappingRequest was null or undefined when calling propertymappingsProviderRadiusUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/radius/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: RadiusProviderPropertyMappingRequestToJSON(requestParameters.radiusProviderPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RadiusProviderPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * RadiusProviderPropertyMapping Viewset
   */
  propertymappingsProviderRadiusUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderRadiusUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsProviderRadiusUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderRadiusUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/radius/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsProviderRadiusUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderRadiusUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsProviderSamlCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.sAMLPropertyMappingRequest === null || requestParameters.sAMLPropertyMappingRequest === void 0) {
        throw new RequiredError("sAMLPropertyMappingRequest", "Required parameter requestParameters.sAMLPropertyMappingRequest was null or undefined when calling propertymappingsProviderSamlCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/saml/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SAMLPropertyMappingRequestToJSON(requestParameters.sAMLPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsProviderSamlCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderSamlCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsProviderSamlDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderSamlDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/saml/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsProviderSamlDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsProviderSamlDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsProviderSamlListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.friendlyName !== void 0) {
        queryParameters["friendly_name"] = requestParameters.friendlyName;
      }
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.managedIsnull !== void 0) {
        queryParameters["managed__isnull"] = requestParameters.managedIsnull;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.samlName !== void 0) {
        queryParameters["saml_name"] = requestParameters.samlName;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/saml/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSAMLPropertyMappingListFromJSON(jsonValue));
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsProviderSamlList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderSamlListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsProviderSamlPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderSamlPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/saml/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedSAMLPropertyMappingRequestToJSON(requestParameters.patchedSAMLPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsProviderSamlPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderSamlPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsProviderSamlRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderSamlRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/saml/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsProviderSamlRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderSamlRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsProviderSamlUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderSamlUpdate.");
      }
      if (requestParameters.sAMLPropertyMappingRequest === null || requestParameters.sAMLPropertyMappingRequest === void 0) {
        throw new RequiredError("sAMLPropertyMappingRequest", "Required parameter requestParameters.sAMLPropertyMappingRequest was null or undefined when calling propertymappingsProviderSamlUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/saml/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: SAMLPropertyMappingRequestToJSON(requestParameters.sAMLPropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLPropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * SAMLPropertyMapping Viewset
   */
  propertymappingsProviderSamlUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderSamlUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsProviderSamlUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderSamlUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/saml/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsProviderSamlUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderSamlUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsProviderScimCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.sCIMMappingRequest === null || requestParameters.sCIMMappingRequest === void 0) {
        throw new RequiredError("sCIMMappingRequest", "Required parameter requestParameters.sCIMMappingRequest was null or undefined when calling propertymappingsProviderScimCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/scim/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SCIMMappingRequestToJSON(requestParameters.sCIMMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMMappingFromJSON(jsonValue));
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsProviderScimCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderScimCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsProviderScimDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderScimDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/scim/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsProviderScimDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsProviderScimDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsProviderScimListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.managedIsnull !== void 0) {
        queryParameters["managed__isnull"] = requestParameters.managedIsnull;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/scim/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSCIMMappingListFromJSON(jsonValue));
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsProviderScimList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderScimListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsProviderScimPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderScimPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/scim/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedSCIMMappingRequestToJSON(requestParameters.patchedSCIMMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMMappingFromJSON(jsonValue));
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsProviderScimPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderScimPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsProviderScimRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderScimRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/scim/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMMappingFromJSON(jsonValue));
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsProviderScimRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderScimRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsProviderScimUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderScimUpdate.");
      }
      if (requestParameters.sCIMMappingRequest === null || requestParameters.sCIMMappingRequest === void 0) {
        throw new RequiredError("sCIMMappingRequest", "Required parameter requestParameters.sCIMMappingRequest was null or undefined when calling propertymappingsProviderScimUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/scim/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: SCIMMappingRequestToJSON(requestParameters.sCIMMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMMappingFromJSON(jsonValue));
    });
  }
  /**
   * SCIMMapping Viewset
   */
  propertymappingsProviderScimUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderScimUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsProviderScimUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderScimUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/scim/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsProviderScimUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderScimUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsProviderScopeCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.scopeMappingRequest === null || requestParameters.scopeMappingRequest === void 0) {
        throw new RequiredError("scopeMappingRequest", "Required parameter requestParameters.scopeMappingRequest was null or undefined when calling propertymappingsProviderScopeCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/scope/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: ScopeMappingRequestToJSON(requestParameters.scopeMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ScopeMappingFromJSON(jsonValue));
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsProviderScopeCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderScopeCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsProviderScopeDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderScopeDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/scope/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsProviderScopeDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsProviderScopeDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsProviderScopeListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.managedIsnull !== void 0) {
        queryParameters["managed__isnull"] = requestParameters.managedIsnull;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.scopeName !== void 0) {
        queryParameters["scope_name"] = requestParameters.scopeName;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/scope/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedScopeMappingListFromJSON(jsonValue));
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsProviderScopeList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderScopeListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsProviderScopePartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderScopePartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/scope/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedScopeMappingRequestToJSON(requestParameters.patchedScopeMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ScopeMappingFromJSON(jsonValue));
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsProviderScopePartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderScopePartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsProviderScopeRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderScopeRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/scope/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ScopeMappingFromJSON(jsonValue));
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsProviderScopeRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderScopeRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsProviderScopeUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderScopeUpdate.");
      }
      if (requestParameters.scopeMappingRequest === null || requestParameters.scopeMappingRequest === void 0) {
        throw new RequiredError("scopeMappingRequest", "Required parameter requestParameters.scopeMappingRequest was null or undefined when calling propertymappingsProviderScopeUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/scope/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: ScopeMappingRequestToJSON(requestParameters.scopeMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ScopeMappingFromJSON(jsonValue));
    });
  }
  /**
   * ScopeMapping Viewset
   */
  propertymappingsProviderScopeUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderScopeUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsProviderScopeUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsProviderScopeUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/provider/scope/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsProviderScopeUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsProviderScopeUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * KerberosSource PropertyMapping Viewset
   */
  propertymappingsSourceKerberosCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.kerberosSourcePropertyMappingRequest === null || requestParameters.kerberosSourcePropertyMappingRequest === void 0) {
        throw new RequiredError("kerberosSourcePropertyMappingRequest", "Required parameter requestParameters.kerberosSourcePropertyMappingRequest was null or undefined when calling propertymappingsSourceKerberosCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/kerberos/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: KerberosSourcePropertyMappingRequestToJSON(requestParameters.kerberosSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => KerberosSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * KerberosSource PropertyMapping Viewset
   */
  propertymappingsSourceKerberosCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceKerberosCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * KerberosSource PropertyMapping Viewset
   */
  propertymappingsSourceKerberosDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceKerberosDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/kerberos/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * KerberosSource PropertyMapping Viewset
   */
  propertymappingsSourceKerberosDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsSourceKerberosDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * KerberosSource PropertyMapping Viewset
   */
  propertymappingsSourceKerberosListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.managedIsnull !== void 0) {
        queryParameters["managed__isnull"] = requestParameters.managedIsnull;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/kerberos/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedKerberosSourcePropertyMappingListFromJSON(jsonValue));
    });
  }
  /**
   * KerberosSource PropertyMapping Viewset
   */
  propertymappingsSourceKerberosList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceKerberosListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * KerberosSource PropertyMapping Viewset
   */
  propertymappingsSourceKerberosPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceKerberosPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/kerberos/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedKerberosSourcePropertyMappingRequestToJSON(requestParameters.patchedKerberosSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => KerberosSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * KerberosSource PropertyMapping Viewset
   */
  propertymappingsSourceKerberosPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceKerberosPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * KerberosSource PropertyMapping Viewset
   */
  propertymappingsSourceKerberosRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceKerberosRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/kerberos/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => KerberosSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * KerberosSource PropertyMapping Viewset
   */
  propertymappingsSourceKerberosRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceKerberosRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * KerberosSource PropertyMapping Viewset
   */
  propertymappingsSourceKerberosUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceKerberosUpdate.");
      }
      if (requestParameters.kerberosSourcePropertyMappingRequest === null || requestParameters.kerberosSourcePropertyMappingRequest === void 0) {
        throw new RequiredError("kerberosSourcePropertyMappingRequest", "Required parameter requestParameters.kerberosSourcePropertyMappingRequest was null or undefined when calling propertymappingsSourceKerberosUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/kerberos/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: KerberosSourcePropertyMappingRequestToJSON(requestParameters.kerberosSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => KerberosSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * KerberosSource PropertyMapping Viewset
   */
  propertymappingsSourceKerberosUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceKerberosUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsSourceKerberosUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceKerberosUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/kerberos/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsSourceKerberosUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceKerberosUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsSourceLdapCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.lDAPSourcePropertyMappingRequest === null || requestParameters.lDAPSourcePropertyMappingRequest === void 0) {
        throw new RequiredError("lDAPSourcePropertyMappingRequest", "Required parameter requestParameters.lDAPSourcePropertyMappingRequest was null or undefined when calling propertymappingsSourceLdapCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/ldap/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: LDAPSourcePropertyMappingRequestToJSON(requestParameters.lDAPSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsSourceLdapCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceLdapCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsSourceLdapDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceLdapDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/ldap/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsSourceLdapDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsSourceLdapDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsSourceLdapListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.managedIsnull !== void 0) {
        queryParameters["managed__isnull"] = requestParameters.managedIsnull;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/ldap/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedLDAPSourcePropertyMappingListFromJSON(jsonValue));
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsSourceLdapList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceLdapListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsSourceLdapPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceLdapPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/ldap/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedLDAPSourcePropertyMappingRequestToJSON(requestParameters.patchedLDAPSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsSourceLdapPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceLdapPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsSourceLdapRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceLdapRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/ldap/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsSourceLdapRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceLdapRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsSourceLdapUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceLdapUpdate.");
      }
      if (requestParameters.lDAPSourcePropertyMappingRequest === null || requestParameters.lDAPSourcePropertyMappingRequest === void 0) {
        throw new RequiredError("lDAPSourcePropertyMappingRequest", "Required parameter requestParameters.lDAPSourcePropertyMappingRequest was null or undefined when calling propertymappingsSourceLdapUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/ldap/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: LDAPSourcePropertyMappingRequestToJSON(requestParameters.lDAPSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * LDAP PropertyMapping Viewset
   */
  propertymappingsSourceLdapUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceLdapUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsSourceLdapUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceLdapUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/ldap/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsSourceLdapUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceLdapUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * OAuthSourcePropertyMapping Viewset
   */
  propertymappingsSourceOauthCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.oAuthSourcePropertyMappingRequest === null || requestParameters.oAuthSourcePropertyMappingRequest === void 0) {
        throw new RequiredError("oAuthSourcePropertyMappingRequest", "Required parameter requestParameters.oAuthSourcePropertyMappingRequest was null or undefined when calling propertymappingsSourceOauthCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/oauth/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: OAuthSourcePropertyMappingRequestToJSON(requestParameters.oAuthSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OAuthSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * OAuthSourcePropertyMapping Viewset
   */
  propertymappingsSourceOauthCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceOauthCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * OAuthSourcePropertyMapping Viewset
   */
  propertymappingsSourceOauthDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceOauthDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/oauth/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * OAuthSourcePropertyMapping Viewset
   */
  propertymappingsSourceOauthDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsSourceOauthDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * OAuthSourcePropertyMapping Viewset
   */
  propertymappingsSourceOauthListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.managedIsnull !== void 0) {
        queryParameters["managed__isnull"] = requestParameters.managedIsnull;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/oauth/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedOAuthSourcePropertyMappingListFromJSON(jsonValue));
    });
  }
  /**
   * OAuthSourcePropertyMapping Viewset
   */
  propertymappingsSourceOauthList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceOauthListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * OAuthSourcePropertyMapping Viewset
   */
  propertymappingsSourceOauthPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceOauthPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/oauth/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedOAuthSourcePropertyMappingRequestToJSON(requestParameters.patchedOAuthSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OAuthSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * OAuthSourcePropertyMapping Viewset
   */
  propertymappingsSourceOauthPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceOauthPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * OAuthSourcePropertyMapping Viewset
   */
  propertymappingsSourceOauthRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceOauthRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/oauth/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OAuthSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * OAuthSourcePropertyMapping Viewset
   */
  propertymappingsSourceOauthRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceOauthRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * OAuthSourcePropertyMapping Viewset
   */
  propertymappingsSourceOauthUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceOauthUpdate.");
      }
      if (requestParameters.oAuthSourcePropertyMappingRequest === null || requestParameters.oAuthSourcePropertyMappingRequest === void 0) {
        throw new RequiredError("oAuthSourcePropertyMappingRequest", "Required parameter requestParameters.oAuthSourcePropertyMappingRequest was null or undefined when calling propertymappingsSourceOauthUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/oauth/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: OAuthSourcePropertyMappingRequestToJSON(requestParameters.oAuthSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OAuthSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * OAuthSourcePropertyMapping Viewset
   */
  propertymappingsSourceOauthUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceOauthUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsSourceOauthUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceOauthUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/oauth/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsSourceOauthUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceOauthUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PlexSourcePropertyMapping Viewset
   */
  propertymappingsSourcePlexCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.plexSourcePropertyMappingRequest === null || requestParameters.plexSourcePropertyMappingRequest === void 0) {
        throw new RequiredError("plexSourcePropertyMappingRequest", "Required parameter requestParameters.plexSourcePropertyMappingRequest was null or undefined when calling propertymappingsSourcePlexCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/plex/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PlexSourcePropertyMappingRequestToJSON(requestParameters.plexSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PlexSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * PlexSourcePropertyMapping Viewset
   */
  propertymappingsSourcePlexCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourcePlexCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PlexSourcePropertyMapping Viewset
   */
  propertymappingsSourcePlexDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourcePlexDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/plex/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * PlexSourcePropertyMapping Viewset
   */
  propertymappingsSourcePlexDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsSourcePlexDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * PlexSourcePropertyMapping Viewset
   */
  propertymappingsSourcePlexListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.managedIsnull !== void 0) {
        queryParameters["managed__isnull"] = requestParameters.managedIsnull;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/plex/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPlexSourcePropertyMappingListFromJSON(jsonValue));
    });
  }
  /**
   * PlexSourcePropertyMapping Viewset
   */
  propertymappingsSourcePlexList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourcePlexListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PlexSourcePropertyMapping Viewset
   */
  propertymappingsSourcePlexPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourcePlexPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/plex/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedPlexSourcePropertyMappingRequestToJSON(requestParameters.patchedPlexSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PlexSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * PlexSourcePropertyMapping Viewset
   */
  propertymappingsSourcePlexPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourcePlexPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PlexSourcePropertyMapping Viewset
   */
  propertymappingsSourcePlexRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourcePlexRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/plex/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PlexSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * PlexSourcePropertyMapping Viewset
   */
  propertymappingsSourcePlexRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourcePlexRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PlexSourcePropertyMapping Viewset
   */
  propertymappingsSourcePlexUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourcePlexUpdate.");
      }
      if (requestParameters.plexSourcePropertyMappingRequest === null || requestParameters.plexSourcePropertyMappingRequest === void 0) {
        throw new RequiredError("plexSourcePropertyMappingRequest", "Required parameter requestParameters.plexSourcePropertyMappingRequest was null or undefined when calling propertymappingsSourcePlexUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/plex/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: PlexSourcePropertyMappingRequestToJSON(requestParameters.plexSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PlexSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * PlexSourcePropertyMapping Viewset
   */
  propertymappingsSourcePlexUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourcePlexUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsSourcePlexUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourcePlexUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/plex/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsSourcePlexUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourcePlexUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLSourcePropertyMapping Viewset
   */
  propertymappingsSourceSamlCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.sAMLSourcePropertyMappingRequest === null || requestParameters.sAMLSourcePropertyMappingRequest === void 0) {
        throw new RequiredError("sAMLSourcePropertyMappingRequest", "Required parameter requestParameters.sAMLSourcePropertyMappingRequest was null or undefined when calling propertymappingsSourceSamlCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/saml/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SAMLSourcePropertyMappingRequestToJSON(requestParameters.sAMLSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * SAMLSourcePropertyMapping Viewset
   */
  propertymappingsSourceSamlCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceSamlCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLSourcePropertyMapping Viewset
   */
  propertymappingsSourceSamlDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceSamlDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/saml/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * SAMLSourcePropertyMapping Viewset
   */
  propertymappingsSourceSamlDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsSourceSamlDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * SAMLSourcePropertyMapping Viewset
   */
  propertymappingsSourceSamlListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.managedIsnull !== void 0) {
        queryParameters["managed__isnull"] = requestParameters.managedIsnull;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/saml/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSAMLSourcePropertyMappingListFromJSON(jsonValue));
    });
  }
  /**
   * SAMLSourcePropertyMapping Viewset
   */
  propertymappingsSourceSamlList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceSamlListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLSourcePropertyMapping Viewset
   */
  propertymappingsSourceSamlPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceSamlPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/saml/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedSAMLSourcePropertyMappingRequestToJSON(requestParameters.patchedSAMLSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * SAMLSourcePropertyMapping Viewset
   */
  propertymappingsSourceSamlPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceSamlPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLSourcePropertyMapping Viewset
   */
  propertymappingsSourceSamlRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceSamlRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/saml/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * SAMLSourcePropertyMapping Viewset
   */
  propertymappingsSourceSamlRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceSamlRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLSourcePropertyMapping Viewset
   */
  propertymappingsSourceSamlUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceSamlUpdate.");
      }
      if (requestParameters.sAMLSourcePropertyMappingRequest === null || requestParameters.sAMLSourcePropertyMappingRequest === void 0) {
        throw new RequiredError("sAMLSourcePropertyMappingRequest", "Required parameter requestParameters.sAMLSourcePropertyMappingRequest was null or undefined when calling propertymappingsSourceSamlUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/saml/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: SAMLSourcePropertyMappingRequestToJSON(requestParameters.sAMLSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * SAMLSourcePropertyMapping Viewset
   */
  propertymappingsSourceSamlUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceSamlUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsSourceSamlUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceSamlUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/saml/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsSourceSamlUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceSamlUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSourcePropertyMapping Viewset
   */
  propertymappingsSourceScimCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.sCIMSourcePropertyMappingRequest === null || requestParameters.sCIMSourcePropertyMappingRequest === void 0) {
        throw new RequiredError("sCIMSourcePropertyMappingRequest", "Required parameter requestParameters.sCIMSourcePropertyMappingRequest was null or undefined when calling propertymappingsSourceScimCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/scim/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SCIMSourcePropertyMappingRequestToJSON(requestParameters.sCIMSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSourcePropertyMapping Viewset
   */
  propertymappingsSourceScimCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceScimCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSourcePropertyMapping Viewset
   */
  propertymappingsSourceScimDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceScimDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/scim/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * SCIMSourcePropertyMapping Viewset
   */
  propertymappingsSourceScimDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.propertymappingsSourceScimDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * SCIMSourcePropertyMapping Viewset
   */
  propertymappingsSourceScimListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.managed) {
        queryParameters["managed"] = requestParameters.managed;
      }
      if (requestParameters.managedIsnull !== void 0) {
        queryParameters["managed__isnull"] = requestParameters.managedIsnull;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/scim/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSCIMSourcePropertyMappingListFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSourcePropertyMapping Viewset
   */
  propertymappingsSourceScimList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceScimListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSourcePropertyMapping Viewset
   */
  propertymappingsSourceScimPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceScimPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/scim/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedSCIMSourcePropertyMappingRequestToJSON(requestParameters.patchedSCIMSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSourcePropertyMapping Viewset
   */
  propertymappingsSourceScimPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceScimPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSourcePropertyMapping Viewset
   */
  propertymappingsSourceScimRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceScimRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/scim/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSourcePropertyMapping Viewset
   */
  propertymappingsSourceScimRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceScimRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMSourcePropertyMapping Viewset
   */
  propertymappingsSourceScimUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceScimUpdate.");
      }
      if (requestParameters.sCIMSourcePropertyMappingRequest === null || requestParameters.sCIMSourcePropertyMappingRequest === void 0) {
        throw new RequiredError("sCIMSourcePropertyMappingRequest", "Required parameter requestParameters.sCIMSourcePropertyMappingRequest was null or undefined when calling propertymappingsSourceScimUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/scim/{pm_uuid}/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: SCIMSourcePropertyMappingRequestToJSON(requestParameters.sCIMSourcePropertyMappingRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMSourcePropertyMappingFromJSON(jsonValue));
    });
  }
  /**
   * SCIMSourcePropertyMapping Viewset
   */
  propertymappingsSourceScimUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceScimUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsSourceScimUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.pmUuid === null || requestParameters.pmUuid === void 0) {
        throw new RequiredError("pmUuid", "Required parameter requestParameters.pmUuid was null or undefined when calling propertymappingsSourceScimUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/propertymappings/source/scim/{pm_uuid}/used_by/`.replace(`{${"pm_uuid"}}`, encodeURIComponent(String(requestParameters.pmUuid))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  propertymappingsSourceScimUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.propertymappingsSourceScimUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
};

export {
  PropertymappingsApi
};
//# sourceMappingURL=chunk-H6O674E7.js.map
