import {
  writeToClipboard
} from "./chunk-QPYNOECS.js";
import {
  showMessage
} from "./chunk-O4CYWEUV.js";
import {
  BaseTaskButton_default
} from "./chunk-KZUPUEAQ.js";
import {
  CoreApi,
  DEFAULT_CONFIG,
  ResponseError,
  n,
  t
} from "./chunk-AMC4UCMS.js";
import {
  msg
} from "./chunk-XFT4DB4U.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/elements/buttons/TokenCopyButton/ak-token-copy-button.ts
var isTokenView = (v) => v && "key" in v && typeof v.key === "string";
var TokenCopyButton = class extends BaseTaskButton_default {
  constructor() {
    super();
    this.callAction = () => {
      if (!this.identifier) {
        return Promise.reject();
      }
      return new CoreApi(DEFAULT_CONFIG).coreTokensViewKeyRetrieve({
        identifier: this.identifier
      });
    };
    this.onSuccess = this.onSuccess.bind(this);
    this.onError = this.onError.bind(this);
  }
  async onSuccess(token) {
    super.onSuccess(token);
    if (!isTokenView(token)) {
      throw new Error(`Unrecognized return from server: ${token}`);
    }
    const wroteToClipboard = await writeToClipboard(token.key);
    const info = wroteToClipboard ? {
      message: msg("The token has been copied to your clipboard")
    } : {
      message: token.key,
      description: msg(
        "The token was displayed because authentik does not have permission to write to the clipboard"
      )
    };
    showMessage({
      level: "info" /* info */,
      ...info
    });
  }
  async onError(error) {
    super.onError(error);
    const message = error instanceof ResponseError ? await error.response.text() : error instanceof Error ? error.toString() : `${error}`;
    showMessage({
      level: "error" /* error */,
      message
    });
  }
};
__decorateClass([
  n()
], TokenCopyButton.prototype, "identifier", 2);
TokenCopyButton = __decorateClass([
  t("ak-token-copy-button")
], TokenCopyButton);
//# sourceMappingURL=chunk-UGHSJ23S.js.map
