import {
  AKElement,
  e,
  n,
  t
} from "./chunk-AMC4UCMS.js";
import {
  D,
  ke
} from "./chunk-XFT4DB4U.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/components/ak-switch-input.ts
var AkSwitchInput = class extends AKElement {
  constructor() {
    super(...arguments);
    this.label = "";
    this.checked = false;
    this.required = false;
    this.help = "";
  }
  // Render into the lightDOM. This effectively erases the shadowDOM nature of this component, but
  // we're not actually using that and, for the meantime, we need the form handlers to be able to
  // find the children of this component.
  //
  // TODO: This abstraction is wrong; it's putting *more* layers in as a way of managing the
  // visual clutter and legibility issues of ak-form-elemental-horizontal and patternfly in
  // general.
  createRenderRoot() {
    return this;
  }
  render() {
    const doCheck = this.checked ? this.checked : void 0;
    return ke` <ak-form-element-horizontal name=${this.name} ?required=${this.required}>
            <label class="pf-c-switch">
                <input class="pf-c-switch__input" type="checkbox" ?checked=${doCheck} />
                <span class="pf-c-switch__toggle">
                    <span class="pf-c-switch__toggle-icon">
                        <i class="fas fa-check" aria-hidden="true"></i>
                    </span>
                </span>
                <span class="pf-c-switch__label">${this.label}</span>
            </label>
            ${this.help.trim() ? ke`<p class="pf-c-form__helper-text">${this.help}</p>` : D}
        </ak-form-element-horizontal>`;
  }
};
__decorateClass([
  n({ type: String })
], AkSwitchInput.prototype, "name", 2);
__decorateClass([
  n({ type: String })
], AkSwitchInput.prototype, "label", 2);
__decorateClass([
  n({ type: Boolean })
], AkSwitchInput.prototype, "checked", 2);
__decorateClass([
  n({ type: Boolean })
], AkSwitchInput.prototype, "required", 2);
__decorateClass([
  n({ type: String })
], AkSwitchInput.prototype, "help", 2);
__decorateClass([
  e("input.pf-c-switch__input[type=checkbox]")
], AkSwitchInput.prototype, "checkbox", 2);
AkSwitchInput = __decorateClass([
  t("ak-switch-input")
], AkSwitchInput);

// src/components/HorizontalLightComponent.ts
var HorizontalLightComponent = class extends AKElement {
  constructor() {
    super(...arguments);
    this.label = "";
    this.required = false;
    this.help = "";
    this.hidden = false;
    this.invalid = false;
    this.errorMessages = [];
  }
  // Render into the lightDOM. This effectively erases the shadowDOM nature of this component, but
  // we're not actually using that and, for the meantime, we need the form handlers to be able to
  // find the children of this component.
  //
  // TODO: This abstraction is wrong; it's putting *more* layers in as a way of managing the
  // visual clutter and legibility issues of ak-form-elemental-horizontal and patternfly in
  // general.
  createRenderRoot() {
    return this;
  }
  renderControl() {
    throw new Error("Must be implemented in a subclass");
  }
  renderHelp() {
    const bigHelp = Array.isArray(this.bighelp) ? this.bighelp : [this.bighelp ?? D];
    return [
      this.help ? ke`<p class="pf-c-form__helper-text">${this.help}</p>` : D,
      ...bigHelp
    ];
  }
  render() {
    return ke`<ak-form-element-horizontal
            label=${this.label}
            ?required=${this.required}
            ?hidden=${this.hidden}
            name=${this.name}
            .errorMessages=${this.errorMessages}
            ?invalid=${this.invalid}
            >
              ${this.renderControl()} 
              ${this.renderHelp()}
        </ak-form-element-horizontal> `;
  }
};
__decorateClass([
  n({ type: String })
], HorizontalLightComponent.prototype, "name", 2);
__decorateClass([
  n({ type: String })
], HorizontalLightComponent.prototype, "label", 2);
__decorateClass([
  n({ type: Boolean })
], HorizontalLightComponent.prototype, "required", 2);
__decorateClass([
  n({ type: String })
], HorizontalLightComponent.prototype, "help", 2);
__decorateClass([
  n({ type: Object })
], HorizontalLightComponent.prototype, "bighelp", 2);
__decorateClass([
  n({ type: Boolean })
], HorizontalLightComponent.prototype, "hidden", 2);
__decorateClass([
  n({ type: Boolean })
], HorizontalLightComponent.prototype, "invalid", 2);
__decorateClass([
  n({ attribute: false })
], HorizontalLightComponent.prototype, "errorMessages", 2);

export {
  HorizontalLightComponent
};
//# sourceMappingURL=chunk-XOIODRMJ.js.map
