import {
  UserFieldsEnum
} from "./chunk-Y74YR4C2.js";
import {
  FlowDesignationEnum
} from "./chunk-N4Y6K6XD.js";
import {
  alert_default
} from "./chunk-DVT5R7IG.js";
import {
  button_default
} from "./chunk-E4FQAZYR.js";
import {
  form_control_default,
  form_default,
  login_default
} from "./chunk-RVW7F5SR.js";
import {
  BaseStage,
  title_default
} from "./chunk-QUIJSWK4.js";
import {
  AKElement,
  n,
  patternfly_base_default,
  t
} from "./chunk-EQUF5YAR.js";
import {
  D,
  Q,
  i,
  ke,
  msg,
  str
} from "./chunk-BL2WZFD2.js";
import {
  __decorateClass
} from "./chunk-QTFYAG5J.js";

// src/admin/sources/utils.ts
function renderSourceIcon(name, iconUrl) {
  const icon = ke`<i class="fas fa-share-square" title="${name}"></i>`;
  if (iconUrl) {
    if (iconUrl.startsWith("fa://")) {
      const url = iconUrl.replaceAll("fa://", "");
      return ke`<i class="fas ${url}" title="${name}"></i>`;
    }
    return ke`<img src="${iconUrl}" alt="${name}" />`;
  }
  return icon;
}

// node_modules/@patternfly/patternfly/components/InputGroup/input-group.css
var input_group_default = ".pf-c-input-group {\n  --pf-global--Color--100: var(--pf-global--Color--dark-100);\n  --pf-global--Color--200: var(--pf-global--Color--dark-200);\n  --pf-global--BorderColor--100: var(--pf-global--BorderColor--dark-100);\n  --pf-global--primary-color--100: var(--pf-global--primary-color--dark-100);\n  --pf-global--link--Color: var(--pf-global--link--Color--dark);\n  --pf-global--link--Color--hover: var(--pf-global--link--Color--dark--hover);\n  --pf-global--BackgroundColor--100: var(--pf-global--BackgroundColor--light-100);\n}\n\n.pf-c-input-group {\n  --pf-c-input-group--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-input-group--child--ZIndex: var(--pf-global--ZIndex--xs);\n  --pf-c-input-group__text--FontSize: var(--pf-global--FontSize--md);\n  --pf-c-input-group__text--PaddingRight: var(--pf-global--spacer--sm);\n  --pf-c-input-group__text--PaddingLeft: var(--pf-global--spacer--sm);\n  --pf-c-input-group__text--Color: var(--pf-global--Color--dark-200);\n  --pf-c-input-group__text--BorderWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-input-group__text--BorderTopColor: var(--pf-global--BorderColor--300);\n  --pf-c-input-group__text--BorderRightColor: var(--pf-global--BorderColor--300);\n  --pf-c-input-group__text--BorderBottomColor: var(--pf-global--BorderColor--200);\n  --pf-c-input-group__text--BorderLeftColor: var(--pf-global--BorderColor--300);\n  --pf-c-input-group__text--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-input-group__textarea--MinHeight: var(--pf-global--spacer--xl);\n  --pf-c-input-group__text--m-disabled--Color: var(--pf-global--disabled-color--100);\n  --pf-c-input-group__text--m-disabled--BackgroundColor: var(--pf-global--disabled-color--300);\n  --pf-c-input-group__text--m-disabled--BorderBottomColor: transparent;\n  --pf-c-input-group--c-form-control--invalid--ZIndex: var(--pf-global--ZIndex--xs);\n  --pf-c-input-group--c-form-control--MarginRight: 0;\n  color: var(--pf-global--Color--100);\n  display: flex;\n  width: 100%;\n  background-color: var(--pf-c-input-group--BackgroundColor);\n}\n.pf-c-input-group.pf-m-plain {\n  --pf-c-input-group--BackgroundColor: transparent;\n}\n.pf-c-input-group > * + * {\n  margin-left: -1px;\n}\n.pf-c-input-group > :focus,\n.pf-c-input-group > :focus-within {\n  z-index: var(--pf-c-input-group--child--ZIndex);\n}\n.pf-c-input-group .pf-c-form-control[aria-invalid=true]:not(:last-child) {\n  margin-right: var(--pf-c-input-group--c-form-control--MarginRight);\n}\n.pf-c-input-group input:not([type=checkbox]):not([type=radio]),\n.pf-c-input-group textarea {\n  flex: 2;\n  min-width: 0;\n}\n.pf-c-input-group textarea {\n  min-height: var(--pf-c-input-group__textarea--MinHeight);\n}\n\n.pf-c-input-group__text {\n  display: flex;\n  align-items: center;\n  padding-right: var(--pf-c-input-group__text--PaddingRight);\n  padding-left: var(--pf-c-input-group__text--PaddingLeft);\n  font-size: var(--pf-c-input-group__text--FontSize);\n  color: var(--pf-c-input-group__text--Color);\n  text-align: center;\n  background-color: var(--pf-c-input-group__text--BackgroundColor);\n  border: var(--pf-c-input-group__text--BorderWidth) solid;\n  border-color: var(--pf-c-input-group__text--BorderTopColor) var(--pf-c-input-group__text--BorderRightColor) var(--pf-c-input-group__text--BorderBottomColor) var(--pf-c-input-group__text--BorderLeftColor);\n}\nlabel.pf-c-input-group__text {\n  cursor: pointer;\n}\n\n.pf-c-input-group__text.pf-m-plain {\n  --pf-c-input-group__text--BorderWidth: 0;\n  margin-left: 0;\n}\n.pf-c-input-group__text.pf-m-disabled {\n  --pf-c-input-group__text--Color: var(--pf-c-input-group__text--m-disabled--Color);\n  --pf-c-input-group__text--BackgroundColor: var(--pf-c-input-group__text--m-disabled--BackgroundColor);\n  --pf-c-input-group__text--BorderBottomColor: var(--pf-c-input-group__text--m-disabled--BorderBottomColor);\n}\n\n:where(.pf-theme-dark) .pf-c-input-group {\n  --pf-c-input-group--BackgroundColor: transparent;\n  --pf-c-input-group__text--BorderTopColor: transparent;\n  --pf-c-input-group__text--BorderRightColor: transparent;\n  --pf-c-input-group__text--BorderBottomColor: var(--pf-global--BorderColor--400);\n  --pf-c-input-group__text--BorderLeftColor: transparent;\n  --pf-c-input-group__text--BackgroundColor: var(--pf-global--palette--black-600);\n  --pf-c-input-group__text--m-disabled--Color: var(--pf-global--palette--black-100);\n  --pf-c-input-group__text--m-disabled--BackgroundColor: var(--pf-global--disabled-color--200);\n}\n:where(.pf-theme-dark) .pf-c-input-group > * + * {\n  margin-left: 0;\n  border-left: 1px solid var(--pf-global--palette--black-700);\n}\n:where(.pf-theme-dark) .pf-c-input-group__text {\n  --pf-c-input-group__text--BorderTopColor: transparent;\n  --pf-c-input-group__text--BorderRightColor: transparent;\n  --pf-c-input-group__text--BorderBottomColor: var(--pf-global--BorderColor--400);\n  --pf-c-input-group__text--BorderLeftColor: transparent;\n}\n:where(.pf-theme-dark) .pf-c-input-group__text.pf-m-plain {\n  --pf-c-input-group__text--BackgroundColor: transparent;\n}\n:where(.pf-theme-dark) .pf-c-input-group__text.pf-m-disabled {\n  --pf-c-input-group__text--BackgroundColor: var(--pf-c-input-group__text--m-disabled--BackgroundColor);\n  color: var(--pf-c-input-group__text--m-disabled--Color);\n}";

// src/flow/components/ak-flow-password-input.ts
var InputPassword = class extends AKElement {
  constructor() {
    super(...arguments);
    this.inputId = "ak-stage-password-input";
    this.name = "password";
    this.label = msg("Password");
    this.placeholder = msg("Please enter your password");
    this.passwordPrefill = "";
    this.errors = {};
    this.allowShowPassword = false;
    this.grabFocus = false;
  }
  static get styles() {
    return [patternfly_base_default, input_group_default, form_control_default, button_default];
  }
  cleanup() {
    if (this.timer) {
      console.debug("authentik/stages/password: cleared focus timer");
      window.clearInterval(this.timer);
      this.timer = void 0;
    }
  }
  // Must support both older browsers and shadyDom; we'll keep using this in-line, but it'll still
  // be in the scope of the parent element, not an independent shadowDOM.
  createRenderRoot() {
    return this;
  }
  // State is saved in the DOM, and read from the DOM. Directly affects the DOM,
  // so no `.requestUpdate()` required. Effect is immediately visible.
  togglePasswordVisibility(ev) {
    const passwordField = this.renderRoot.querySelector(`#${this.inputId}`);
    ev.stopPropagation();
    ev.preventDefault();
    if (!passwordField) {
      throw new Error("ak-flow-password-input: unable to identify input field");
    }
    passwordField.type = passwordField.type === "password" ? "text" : "password";
    this.renderPasswordVisibilityFeatures(passwordField);
  }
  // In the unlikely event that we want to make "show password" the _default_ behavior, this
  // effect handler is broken out into its own method. The current behavior in the main
  // `.render()` method assumes the field is of type "password." To have this effect, er, take
  // effect, call it in an `.updated()` method.
  renderPasswordVisibilityFeatures(passwordField) {
    const toggleId = `#${this.inputId}-visibility-toggle`;
    const visibilityToggle = this.renderRoot.querySelector(toggleId);
    if (!visibilityToggle) {
      return;
    }
    const show = passwordField.type === "password";
    visibilityToggle?.setAttribute(
      "aria-label",
      show ? msg("Show password") : msg("Hide password")
    );
    visibilityToggle?.querySelector("i")?.remove();
    Q(
      show ? ke`<i class="fas fa-eye" aria-hidden="true"></i>` : ke`<i class="fas fa-eye-slash" aria-hidden="true"></i>`,
      visibilityToggle
    );
  }
  renderInput() {
    this.input = document.createElement("input");
    this.input.id = `${this.inputId}`;
    this.input.type = "password";
    this.input.name = this.name;
    this.input.placeholder = this.placeholder;
    this.input.autofocus = true;
    this.input.autocomplete = "current-password";
    this.input.classList.add("pf-c-form-control");
    this.input.required = true;
    this.input.value = this.passwordPrefill ?? "";
    if (this.invalid) {
      this.input.setAttribute("aria-invalid", this.invalid);
    }
    if (this.grabFocus) {
      this.timer = window.setInterval(() => {
        if (!this.input) {
          return;
        }
        const rootEl = document.activeElement;
        const isActive = (el) => {
          if (!rootEl) return false;
          if (!("shadowRoot" in rootEl)) return false;
          if (rootEl.shadowRoot === null) return false;
          if (rootEl.shadowRoot.activeElement === el) return true;
          return isActive(rootEl.shadowRoot.activeElement);
        };
        if (isActive(this.input)) {
          this.cleanup();
        }
        this.input.focus();
      }, 10);
      console.debug("authentik/stages/password: started focus timer");
    }
    return this.input;
  }
  render() {
    return ke` <ak-form-element
            label="${this.label}"
            required
            class="pf-c-form__group"
            .errors=${this.errors}
        >
            <div class="pf-c-input-group">
                ${this.renderInput()}
                ${this.allowShowPassword ? ke` <button
                          class="pf-c-button pf-m-control ak-stage-password-toggle-visibility"
                          type="button"
                          aria-label=${msg("Show password")}
                          @click=${(ev) => this.togglePasswordVisibility(ev)}
                      >
                          <i class="fas fa-eye" aria-hidden="true"></i>
                      </button>` : D}
            </div>
        </ak-form-element>`;
  }
};
__decorateClass([
  n({ type: String, attribute: "input-id" })
], InputPassword.prototype, "inputId", 2);
__decorateClass([
  n({ type: String })
], InputPassword.prototype, "name", 2);
__decorateClass([
  n({ type: String })
], InputPassword.prototype, "label", 2);
__decorateClass([
  n({ type: String })
], InputPassword.prototype, "placeholder", 2);
__decorateClass([
  n({ type: String, attribute: "prefill" })
], InputPassword.prototype, "passwordPrefill", 2);
__decorateClass([
  n({ type: Object })
], InputPassword.prototype, "errors", 2);
__decorateClass([
  n({ type: String })
], InputPassword.prototype, "invalid", 2);
__decorateClass([
  n({ type: Boolean, attribute: "allow-show-password" })
], InputPassword.prototype, "allowShowPassword", 2);
__decorateClass([
  n({ type: Boolean, attribute: "grab-focus" })
], InputPassword.prototype, "grabFocus", 2);
InputPassword = __decorateClass([
  t("ak-flow-input-password")
], InputPassword);

// src/flow/stages/identification/IdentificationStage.ts
var PasswordManagerPrefill = {
  password: void 0,
  totp: void 0
};
var OR_LIST_FORMATTERS = new Intl.ListFormat("default", {
  style: "short",
  type: "disjunction"
});
var IdentificationStage = class extends BaseStage {
  static get styles() {
    return [
      patternfly_base_default,
      alert_default,
      input_group_default,
      login_default,
      form_default,
      form_control_default,
      title_default,
      button_default,
      /* login page's icons */
      i`
                .pf-c-login__main-footer-links-item button {
                    background-color: transparent;
                    border: 0;
                    display: flex;
                    align-items: stretch;
                }
                .pf-c-login__main-footer-links-item img {
                    fill: var(--pf-c-login__main-footer-links-item-link-svg--Fill);
                    width: 100px;
                    max-width: var(--pf-c-login__main-footer-links-item-link-svg--Width);
                    height: 100%;
                    max-height: var(--pf-c-login__main-footer-links-item-link-svg--Height);
                }
            `
    ];
  }
  updated(changedProperties) {
    if (changedProperties.has("challenge") && this.challenge !== void 0) {
      this.autoRedirect();
      this.createHelperForm();
    }
  }
  autoRedirect() {
    if (!this.challenge) return;
    if (this.challenge.sources?.length !== 1) return;
    if ((this.challenge.userFields || []).length !== 0) return;
    if (this.challenge.passwordlessUrl) return;
    const source = this.challenge.sources[0];
    this.host.challenge = source.challenge;
  }
  createHelperForm() {
    const compatMode = "ShadyDOM" in window;
    this.form = document.createElement("form");
    document.documentElement.appendChild(this.form);
    if (!compatMode) {
      const username = document.createElement("input");
      username.setAttribute("type", "text");
      username.setAttribute("name", "username");
      username.setAttribute("autocomplete", "username");
      username.onkeyup = (ev) => {
        const el = ev.target;
        (this.shadowRoot || this).querySelectorAll("input[name=uidField]").forEach((input) => {
          input.value = el.value;
          input.focus();
        });
      };
      this.form.appendChild(username);
    }
    if (!compatMode && !this.challenge.passwordFields) {
      const password = document.createElement("input");
      password.setAttribute("type", "password");
      password.setAttribute("name", "password");
      password.setAttribute("autocomplete", "current-password");
      password.onkeyup = (ev) => {
        if (ev.key == "Enter") {
          this.submitForm(ev);
        }
        const el = ev.target;
        PasswordManagerPrefill.password = el.value;
        (this.shadowRoot || this).querySelectorAll("input[name=uidField]").forEach((input) => {
          input.focus();
        });
      };
      this.form.appendChild(password);
    }
    const totp = document.createElement("input");
    totp.setAttribute("type", "text");
    totp.setAttribute("name", "code");
    totp.setAttribute("autocomplete", "one-time-code");
    totp.onkeyup = (ev) => {
      if (ev.key == "Enter") {
        this.submitForm(ev);
      }
      const el = ev.target;
      PasswordManagerPrefill.totp = el.value;
      (this.shadowRoot || this).querySelectorAll("input[name=uidField]").forEach((input) => {
        input.focus();
      });
    };
    this.form.appendChild(totp);
  }
  cleanup() {
    if (this.form) {
      this.form.remove();
    }
  }
  renderSource(source) {
    const icon = renderSourceIcon(source.name, source.iconUrl);
    return ke`<li class="pf-c-login__main-footer-links-item">
            <button
                type="button"
                @click=${() => {
      if (!this.host) return;
      this.host.challenge = source.challenge;
    }}
                class=${this.challenge.showSourceLabels ? "pf-c-button pf-m-link" : ""}
            >
                <span class="pf-c-button__icon pf-m-start">${icon}</span>
                ${this.challenge.showSourceLabels ? source.name : ""}
            </button>
        </li>`;
  }
  renderFooter() {
    if (!this.challenge?.enrollUrl && !this.challenge?.recoveryUrl) {
      return D;
    }
    return ke`<div class="pf-c-login__main-footer-band">
            ${this.challenge.enrollUrl ? ke`<p class="pf-c-login__main-footer-band-item">
                      ${msg("Need an account?")}
                      <a id="enroll" href="${this.challenge.enrollUrl}">${msg("Sign up.")}</a>
                  </p>` : D}
            ${this.challenge.recoveryUrl ? ke`<p class="pf-c-login__main-footer-band-item">
                      <a id="recovery" href="${this.challenge.recoveryUrl}"
                          >${msg("Forgot username or password?")}</a
                      >
                  </p>` : D}
        </div>`;
  }
  renderInput() {
    let type = "text";
    if (!this.challenge?.userFields || this.challenge.userFields.length === 0) {
      return ke`<p>${msg("Select one of the options below to continue.")}</p>`;
    }
    const fields = (this.challenge?.userFields || []).sort();
    if (fields.includes(UserFieldsEnum.Email) && fields.length === 1) {
      type = "email";
    }
    const uiFields = {
      [UserFieldsEnum.Username]: msg("Username"),
      [UserFieldsEnum.Email]: msg("Email"),
      [UserFieldsEnum.Upn]: msg("UPN")
    };
    const label = OR_LIST_FORMATTERS.format(fields.map((f) => uiFields[f]));
    return ke`${this.challenge.flowDesignation === FlowDesignationEnum.Recovery ? ke`
                      <p>
                          ${msg(
      "Enter the email associated with your account, and we'll send you a link to reset your password."
    )}
                      </p>
                  ` : D}
            <ak-form-element
                label=${label}
                required
                class="pf-c-form__group"
                .errors=${(this.challenge.responseErrors || {})["uid_field"]}
            >
                <input
                    type=${type}
                    name="uidField"
                    placeholder=${label}
                    autofocus=""
                    autocomplete="username"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element>
            ${this.challenge.passwordFields ? ke`
                      <ak-flow-input-password
                          label=${msg("Password")}
                          inputId="ak-stage-identification-password"
                          required
                          class="pf-c-form__group"
                          .errors=${(this.challenge?.responseErrors || {})["password"]}
                          ?allow-show-password=${this.challenge.allowShowPassword}
                          prefill=${PasswordManagerPrefill["password"] ?? ""}
                      ></ak-flow-input-password>
                  ` : D}
            ${this.renderNonFieldErrors()}
            <div class="pf-c-form__group pf-m-action">
                <button type="submit" class="pf-c-button pf-m-primary pf-m-block">
                    ${this.challenge.primaryAction}
                </button>
            </div>
            ${this.challenge.passwordlessUrl ? ke`<ak-divider>${msg("Or")}</ak-divider>` : D}`;
  }
  render() {
    if (!this.challenge) {
      return ke`<ak-empty-state loading> </ak-empty-state>`;
    }
    return ke`<header class="pf-c-login__main-header">
                <h1 class="pf-c-title pf-m-3xl">${this.challenge.flowInfo?.title}</h1>
            </header>
            <div class="pf-c-login__main-body">
                <form
                    class="pf-c-form"
                    @submit=${(e) => {
      this.submitForm(e);
    }}
                >
                    ${this.challenge.applicationPre ? ke`<p>
                              ${msg(str`Login to continue to ${this.challenge.applicationPre}.`)}
                          </p>` : D}
                    ${this.renderInput()}
                    ${this.challenge.passwordlessUrl ? ke`
                              <div>
                                  <a
                                      href=${this.challenge.passwordlessUrl}
                                      class="pf-c-button pf-m-secondary pf-m-block"
                                  >
                                      ${msg("Use a security key")}
                                  </a>
                              </div>
                          ` : D}
                </form>
            </div>
            <footer class="pf-c-login__main-footer">
                <ul class="pf-c-login__main-footer-links">
                    ${(this.challenge.sources || []).map((source) => {
      return this.renderSource(source);
    })}
                </ul>
                ${this.renderFooter()}
            </footer>`;
  }
};
IdentificationStage = __decorateClass([
  t("ak-stage-identification")
], IdentificationStage);

export {
  input_group_default,
  PasswordManagerPrefill,
  OR_LIST_FORMATTERS,
  IdentificationStage
};
//# sourceMappingURL=chunk-GD45S3QK.js.map
