import {
  SAMLMetadataFromJSON,
  SyncStatusFromJSON
} from "./chunk-GNYEGOJX.js";
import {
  BaseAPI,
  ClientTypeEnumFromJSON,
  ClientTypeEnumToJSON,
  DigestAlgorithmEnumFromJSON,
  DigestAlgorithmEnumToJSON,
  GoogleWorkspaceProviderRequestToJSON,
  GroupMemberFromJSON,
  IssuerModeEnumFromJSON,
  IssuerModeEnumToJSON,
  JSONApiResponse,
  LDAPAPIAccessModeFromJSON,
  LDAPAPIAccessModeToJSON,
  LDAPProviderRequestToJSON,
  LogEventFromJSON,
  MatchingModeEnumFromJSON,
  MicrosoftEntraProviderRequestToJSON,
  OAuth2ProviderRequestToJSON,
  OutgoingSyncDeleteActionFromJSON,
  OutgoingSyncDeleteActionToJSON,
  PaginationFromJSON,
  ProviderFromJSON,
  ProxyModeFromJSON,
  ProxyModeToJSON,
  ProxyProviderRequestToJSON,
  RACProviderRequestToJSON,
  RadiusProviderRequestToJSON,
  RedirectURIRequestToJSON,
  RequiredError,
  SAMLProviderRequestToJSON,
  SCIMProviderRequestToJSON,
  SignatureAlgorithmEnumFromJSON,
  SignatureAlgorithmEnumToJSON,
  SpBindingEnumFromJSON,
  SpBindingEnumToJSON,
  SubModeEnumFromJSON,
  SubModeEnumToJSON,
  TypeCreateFromJSON,
  UsedByFromJSON,
  UserGroupFromJSON,
  VoidApiResponse,
  canConsumeForm,
  exists
} from "./chunk-AMC4UCMS.js";

// node_modules/@goauthentik/api/dist/esm/models/RACProvider.js
function RACProviderFromJSON(json) {
  return RACProviderFromJSONTyped(json, false);
}
function RACProviderFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "authenticationFlow": !exists(json, "authentication_flow") ? void 0 : json["authentication_flow"],
    "authorizationFlow": json["authorization_flow"],
    "propertyMappings": !exists(json, "property_mappings") ? void 0 : json["property_mappings"],
    "component": json["component"],
    "assignedApplicationSlug": json["assigned_application_slug"],
    "assignedApplicationName": json["assigned_application_name"],
    "assignedBackchannelApplicationSlug": json["assigned_backchannel_application_slug"],
    "assignedBackchannelApplicationName": json["assigned_backchannel_application_name"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "settings": !exists(json, "settings") ? void 0 : json["settings"],
    "outpostSet": json["outpost_set"],
    "connectionExpiry": !exists(json, "connection_expiry") ? void 0 : json["connection_expiry"],
    "deleteTokenOnDisconnect": !exists(json, "delete_token_on_disconnect") ? void 0 : json["delete_token_on_disconnect"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/RedirectURI.js
function RedirectURIFromJSON(json) {
  return RedirectURIFromJSONTyped(json, false);
}
function RedirectURIFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "matchingMode": MatchingModeEnumFromJSON(json["matching_mode"]),
    "url": json["url"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/OAuth2Provider.js
function OAuth2ProviderFromJSON(json) {
  return OAuth2ProviderFromJSONTyped(json, false);
}
function OAuth2ProviderFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "authenticationFlow": !exists(json, "authentication_flow") ? void 0 : json["authentication_flow"],
    "authorizationFlow": json["authorization_flow"],
    "invalidationFlow": json["invalidation_flow"],
    "propertyMappings": !exists(json, "property_mappings") ? void 0 : json["property_mappings"],
    "component": json["component"],
    "assignedApplicationSlug": json["assigned_application_slug"],
    "assignedApplicationName": json["assigned_application_name"],
    "assignedBackchannelApplicationSlug": json["assigned_backchannel_application_slug"],
    "assignedBackchannelApplicationName": json["assigned_backchannel_application_name"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "clientType": !exists(json, "client_type") ? void 0 : ClientTypeEnumFromJSON(json["client_type"]),
    "clientId": !exists(json, "client_id") ? void 0 : json["client_id"],
    "clientSecret": !exists(json, "client_secret") ? void 0 : json["client_secret"],
    "accessCodeValidity": !exists(json, "access_code_validity") ? void 0 : json["access_code_validity"],
    "accessTokenValidity": !exists(json, "access_token_validity") ? void 0 : json["access_token_validity"],
    "refreshTokenValidity": !exists(json, "refresh_token_validity") ? void 0 : json["refresh_token_validity"],
    "includeClaimsInIdToken": !exists(json, "include_claims_in_id_token") ? void 0 : json["include_claims_in_id_token"],
    "signingKey": !exists(json, "signing_key") ? void 0 : json["signing_key"],
    "encryptionKey": !exists(json, "encryption_key") ? void 0 : json["encryption_key"],
    "redirectUris": json["redirect_uris"].map(RedirectURIFromJSON),
    "subMode": !exists(json, "sub_mode") ? void 0 : SubModeEnumFromJSON(json["sub_mode"]),
    "issuerMode": !exists(json, "issuer_mode") ? void 0 : IssuerModeEnumFromJSON(json["issuer_mode"]),
    "jwksSources": !exists(json, "jwks_sources") ? void 0 : json["jwks_sources"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/GoogleWorkspaceProvider.js
function GoogleWorkspaceProviderFromJSON(json) {
  return GoogleWorkspaceProviderFromJSONTyped(json, false);
}
function GoogleWorkspaceProviderFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "propertyMappings": !exists(json, "property_mappings") ? void 0 : json["property_mappings"],
    "propertyMappingsGroup": !exists(json, "property_mappings_group") ? void 0 : json["property_mappings_group"],
    "component": json["component"],
    "assignedBackchannelApplicationSlug": json["assigned_backchannel_application_slug"],
    "assignedBackchannelApplicationName": json["assigned_backchannel_application_name"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "delegatedSubject": json["delegated_subject"],
    "credentials": json["credentials"],
    "scopes": !exists(json, "scopes") ? void 0 : json["scopes"],
    "excludeUsersServiceAccount": !exists(json, "exclude_users_service_account") ? void 0 : json["exclude_users_service_account"],
    "filterGroup": !exists(json, "filter_group") ? void 0 : json["filter_group"],
    "userDeleteAction": !exists(json, "user_delete_action") ? void 0 : OutgoingSyncDeleteActionFromJSON(json["user_delete_action"]),
    "groupDeleteAction": !exists(json, "group_delete_action") ? void 0 : OutgoingSyncDeleteActionFromJSON(json["group_delete_action"]),
    "defaultGroupEmailDomain": json["default_group_email_domain"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/GoogleWorkspaceProviderGroup.js
function GoogleWorkspaceProviderGroupFromJSON(json) {
  return GoogleWorkspaceProviderGroupFromJSONTyped(json, false);
}
function GoogleWorkspaceProviderGroupFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "id": json["id"],
    "googleId": json["google_id"],
    "group": json["group"],
    "groupObj": UserGroupFromJSON(json["group_obj"]),
    "provider": json["provider"],
    "attributes": json["attributes"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/GoogleWorkspaceProviderGroupRequest.js
function GoogleWorkspaceProviderGroupRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "google_id": value.googleId,
    "group": value.group,
    "provider": value.provider
  };
}

// node_modules/@goauthentik/api/dist/esm/models/GoogleWorkspaceProviderUser.js
function GoogleWorkspaceProviderUserFromJSON(json) {
  return GoogleWorkspaceProviderUserFromJSONTyped(json, false);
}
function GoogleWorkspaceProviderUserFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "id": json["id"],
    "googleId": json["google_id"],
    "user": json["user"],
    "userObj": GroupMemberFromJSON(json["user_obj"]),
    "provider": json["provider"],
    "attributes": json["attributes"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/GoogleWorkspaceProviderUserRequest.js
function GoogleWorkspaceProviderUserRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "google_id": value.googleId,
    "user": value.user,
    "provider": value.provider
  };
}

// node_modules/@goauthentik/api/dist/esm/models/LDAPProvider.js
function LDAPProviderFromJSON(json) {
  return LDAPProviderFromJSONTyped(json, false);
}
function LDAPProviderFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "authenticationFlow": !exists(json, "authentication_flow") ? void 0 : json["authentication_flow"],
    "authorizationFlow": json["authorization_flow"],
    "invalidationFlow": json["invalidation_flow"],
    "propertyMappings": !exists(json, "property_mappings") ? void 0 : json["property_mappings"],
    "component": json["component"],
    "assignedApplicationSlug": json["assigned_application_slug"],
    "assignedApplicationName": json["assigned_application_name"],
    "assignedBackchannelApplicationSlug": json["assigned_backchannel_application_slug"],
    "assignedBackchannelApplicationName": json["assigned_backchannel_application_name"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "baseDn": !exists(json, "base_dn") ? void 0 : json["base_dn"],
    "certificate": !exists(json, "certificate") ? void 0 : json["certificate"],
    "tlsServerName": !exists(json, "tls_server_name") ? void 0 : json["tls_server_name"],
    "uidStartNumber": !exists(json, "uid_start_number") ? void 0 : json["uid_start_number"],
    "gidStartNumber": !exists(json, "gid_start_number") ? void 0 : json["gid_start_number"],
    "outpostSet": json["outpost_set"],
    "searchMode": !exists(json, "search_mode") ? void 0 : LDAPAPIAccessModeFromJSON(json["search_mode"]),
    "bindMode": !exists(json, "bind_mode") ? void 0 : LDAPAPIAccessModeFromJSON(json["bind_mode"]),
    "mfaSupport": !exists(json, "mfa_support") ? void 0 : json["mfa_support"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/MicrosoftEntraProvider.js
function MicrosoftEntraProviderFromJSON(json) {
  return MicrosoftEntraProviderFromJSONTyped(json, false);
}
function MicrosoftEntraProviderFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "propertyMappings": !exists(json, "property_mappings") ? void 0 : json["property_mappings"],
    "propertyMappingsGroup": !exists(json, "property_mappings_group") ? void 0 : json["property_mappings_group"],
    "component": json["component"],
    "assignedBackchannelApplicationSlug": json["assigned_backchannel_application_slug"],
    "assignedBackchannelApplicationName": json["assigned_backchannel_application_name"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "clientId": json["client_id"],
    "clientSecret": json["client_secret"],
    "tenantId": json["tenant_id"],
    "excludeUsersServiceAccount": !exists(json, "exclude_users_service_account") ? void 0 : json["exclude_users_service_account"],
    "filterGroup": !exists(json, "filter_group") ? void 0 : json["filter_group"],
    "userDeleteAction": !exists(json, "user_delete_action") ? void 0 : OutgoingSyncDeleteActionFromJSON(json["user_delete_action"]),
    "groupDeleteAction": !exists(json, "group_delete_action") ? void 0 : OutgoingSyncDeleteActionFromJSON(json["group_delete_action"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/MicrosoftEntraProviderGroup.js
function MicrosoftEntraProviderGroupFromJSON(json) {
  return MicrosoftEntraProviderGroupFromJSONTyped(json, false);
}
function MicrosoftEntraProviderGroupFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "id": json["id"],
    "microsoftId": json["microsoft_id"],
    "group": json["group"],
    "groupObj": UserGroupFromJSON(json["group_obj"]),
    "provider": json["provider"],
    "attributes": json["attributes"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/MicrosoftEntraProviderGroupRequest.js
function MicrosoftEntraProviderGroupRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "microsoft_id": value.microsoftId,
    "group": value.group,
    "provider": value.provider
  };
}

// node_modules/@goauthentik/api/dist/esm/models/MicrosoftEntraProviderUser.js
function MicrosoftEntraProviderUserFromJSON(json) {
  return MicrosoftEntraProviderUserFromJSONTyped(json, false);
}
function MicrosoftEntraProviderUserFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "id": json["id"],
    "microsoftId": json["microsoft_id"],
    "user": json["user"],
    "userObj": GroupMemberFromJSON(json["user_obj"]),
    "provider": json["provider"],
    "attributes": json["attributes"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/MicrosoftEntraProviderUserRequest.js
function MicrosoftEntraProviderUserRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "microsoft_id": value.microsoftId,
    "user": value.user,
    "provider": value.provider
  };
}

// node_modules/@goauthentik/api/dist/esm/models/OAuth2ProviderSetupURLs.js
function OAuth2ProviderSetupURLsFromJSON(json) {
  return OAuth2ProviderSetupURLsFromJSONTyped(json, false);
}
function OAuth2ProviderSetupURLsFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "issuer": json["issuer"],
    "authorize": json["authorize"],
    "token": json["token"],
    "userInfo": json["user_info"],
    "providerInfo": json["provider_info"],
    "logout": json["logout"],
    "jwks": json["jwks"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedGoogleWorkspaceProviderGroupList.js
function PaginatedGoogleWorkspaceProviderGroupListFromJSON(json) {
  return PaginatedGoogleWorkspaceProviderGroupListFromJSONTyped(json, false);
}
function PaginatedGoogleWorkspaceProviderGroupListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(GoogleWorkspaceProviderGroupFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedGoogleWorkspaceProviderList.js
function PaginatedGoogleWorkspaceProviderListFromJSON(json) {
  return PaginatedGoogleWorkspaceProviderListFromJSONTyped(json, false);
}
function PaginatedGoogleWorkspaceProviderListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(GoogleWorkspaceProviderFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedGoogleWorkspaceProviderUserList.js
function PaginatedGoogleWorkspaceProviderUserListFromJSON(json) {
  return PaginatedGoogleWorkspaceProviderUserListFromJSONTyped(json, false);
}
function PaginatedGoogleWorkspaceProviderUserListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(GoogleWorkspaceProviderUserFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedLDAPProviderList.js
function PaginatedLDAPProviderListFromJSON(json) {
  return PaginatedLDAPProviderListFromJSONTyped(json, false);
}
function PaginatedLDAPProviderListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(LDAPProviderFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedMicrosoftEntraProviderGroupList.js
function PaginatedMicrosoftEntraProviderGroupListFromJSON(json) {
  return PaginatedMicrosoftEntraProviderGroupListFromJSONTyped(json, false);
}
function PaginatedMicrosoftEntraProviderGroupListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(MicrosoftEntraProviderGroupFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedMicrosoftEntraProviderList.js
function PaginatedMicrosoftEntraProviderListFromJSON(json) {
  return PaginatedMicrosoftEntraProviderListFromJSONTyped(json, false);
}
function PaginatedMicrosoftEntraProviderListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(MicrosoftEntraProviderFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedMicrosoftEntraProviderUserList.js
function PaginatedMicrosoftEntraProviderUserListFromJSON(json) {
  return PaginatedMicrosoftEntraProviderUserListFromJSONTyped(json, false);
}
function PaginatedMicrosoftEntraProviderUserListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(MicrosoftEntraProviderUserFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedOAuth2ProviderList.js
function PaginatedOAuth2ProviderListFromJSON(json) {
  return PaginatedOAuth2ProviderListFromJSONTyped(json, false);
}
function PaginatedOAuth2ProviderListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(OAuth2ProviderFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedProviderList.js
function PaginatedProviderListFromJSON(json) {
  return PaginatedProviderListFromJSONTyped(json, false);
}
function PaginatedProviderListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ProviderFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ProxyProvider.js
function ProxyProviderFromJSON(json) {
  return ProxyProviderFromJSONTyped(json, false);
}
function ProxyProviderFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "authenticationFlow": !exists(json, "authentication_flow") ? void 0 : json["authentication_flow"],
    "authorizationFlow": json["authorization_flow"],
    "invalidationFlow": json["invalidation_flow"],
    "propertyMappings": !exists(json, "property_mappings") ? void 0 : json["property_mappings"],
    "component": json["component"],
    "assignedApplicationSlug": json["assigned_application_slug"],
    "assignedApplicationName": json["assigned_application_name"],
    "assignedBackchannelApplicationSlug": json["assigned_backchannel_application_slug"],
    "assignedBackchannelApplicationName": json["assigned_backchannel_application_name"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "clientId": json["client_id"],
    "internalHost": !exists(json, "internal_host") ? void 0 : json["internal_host"],
    "externalHost": json["external_host"],
    "internalHostSslValidation": !exists(json, "internal_host_ssl_validation") ? void 0 : json["internal_host_ssl_validation"],
    "certificate": !exists(json, "certificate") ? void 0 : json["certificate"],
    "skipPathRegex": !exists(json, "skip_path_regex") ? void 0 : json["skip_path_regex"],
    "basicAuthEnabled": !exists(json, "basic_auth_enabled") ? void 0 : json["basic_auth_enabled"],
    "basicAuthPasswordAttribute": !exists(json, "basic_auth_password_attribute") ? void 0 : json["basic_auth_password_attribute"],
    "basicAuthUserAttribute": !exists(json, "basic_auth_user_attribute") ? void 0 : json["basic_auth_user_attribute"],
    "mode": !exists(json, "mode") ? void 0 : ProxyModeFromJSON(json["mode"]),
    "interceptHeaderAuth": !exists(json, "intercept_header_auth") ? void 0 : json["intercept_header_auth"],
    "redirectUris": json["redirect_uris"].map(RedirectURIFromJSON),
    "cookieDomain": !exists(json, "cookie_domain") ? void 0 : json["cookie_domain"],
    "jwksSources": !exists(json, "jwks_sources") ? void 0 : json["jwks_sources"],
    "accessTokenValidity": !exists(json, "access_token_validity") ? void 0 : json["access_token_validity"],
    "refreshTokenValidity": !exists(json, "refresh_token_validity") ? void 0 : json["refresh_token_validity"],
    "outpostSet": json["outpost_set"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedProxyProviderList.js
function PaginatedProxyProviderListFromJSON(json) {
  return PaginatedProxyProviderListFromJSONTyped(json, false);
}
function PaginatedProxyProviderListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ProxyProviderFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedRACProviderList.js
function PaginatedRACProviderListFromJSON(json) {
  return PaginatedRACProviderListFromJSONTyped(json, false);
}
function PaginatedRACProviderListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(RACProviderFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/RadiusProvider.js
function RadiusProviderFromJSON(json) {
  return RadiusProviderFromJSONTyped(json, false);
}
function RadiusProviderFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "authenticationFlow": !exists(json, "authentication_flow") ? void 0 : json["authentication_flow"],
    "authorizationFlow": json["authorization_flow"],
    "invalidationFlow": json["invalidation_flow"],
    "propertyMappings": !exists(json, "property_mappings") ? void 0 : json["property_mappings"],
    "component": json["component"],
    "assignedApplicationSlug": json["assigned_application_slug"],
    "assignedApplicationName": json["assigned_application_name"],
    "assignedBackchannelApplicationSlug": json["assigned_backchannel_application_slug"],
    "assignedBackchannelApplicationName": json["assigned_backchannel_application_name"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "clientNetworks": !exists(json, "client_networks") ? void 0 : json["client_networks"],
    "sharedSecret": !exists(json, "shared_secret") ? void 0 : json["shared_secret"],
    "outpostSet": json["outpost_set"],
    "mfaSupport": !exists(json, "mfa_support") ? void 0 : json["mfa_support"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedRadiusProviderList.js
function PaginatedRadiusProviderListFromJSON(json) {
  return PaginatedRadiusProviderListFromJSONTyped(json, false);
}
function PaginatedRadiusProviderListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(RadiusProviderFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SAMLProvider.js
function SAMLProviderFromJSON(json) {
  return SAMLProviderFromJSONTyped(json, false);
}
function SAMLProviderFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "authenticationFlow": !exists(json, "authentication_flow") ? void 0 : json["authentication_flow"],
    "authorizationFlow": json["authorization_flow"],
    "invalidationFlow": json["invalidation_flow"],
    "propertyMappings": !exists(json, "property_mappings") ? void 0 : json["property_mappings"],
    "component": json["component"],
    "assignedApplicationSlug": json["assigned_application_slug"],
    "assignedApplicationName": json["assigned_application_name"],
    "assignedBackchannelApplicationSlug": json["assigned_backchannel_application_slug"],
    "assignedBackchannelApplicationName": json["assigned_backchannel_application_name"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "acsUrl": json["acs_url"],
    "audience": !exists(json, "audience") ? void 0 : json["audience"],
    "issuer": !exists(json, "issuer") ? void 0 : json["issuer"],
    "assertionValidNotBefore": !exists(json, "assertion_valid_not_before") ? void 0 : json["assertion_valid_not_before"],
    "assertionValidNotOnOrAfter": !exists(json, "assertion_valid_not_on_or_after") ? void 0 : json["assertion_valid_not_on_or_after"],
    "sessionValidNotOnOrAfter": !exists(json, "session_valid_not_on_or_after") ? void 0 : json["session_valid_not_on_or_after"],
    "nameIdMapping": !exists(json, "name_id_mapping") ? void 0 : json["name_id_mapping"],
    "digestAlgorithm": !exists(json, "digest_algorithm") ? void 0 : DigestAlgorithmEnumFromJSON(json["digest_algorithm"]),
    "signatureAlgorithm": !exists(json, "signature_algorithm") ? void 0 : SignatureAlgorithmEnumFromJSON(json["signature_algorithm"]),
    "signingKp": !exists(json, "signing_kp") ? void 0 : json["signing_kp"],
    "verificationKp": !exists(json, "verification_kp") ? void 0 : json["verification_kp"],
    "encryptionKp": !exists(json, "encryption_kp") ? void 0 : json["encryption_kp"],
    "signAssertion": !exists(json, "sign_assertion") ? void 0 : json["sign_assertion"],
    "signResponse": !exists(json, "sign_response") ? void 0 : json["sign_response"],
    "spBinding": !exists(json, "sp_binding") ? void 0 : SpBindingEnumFromJSON(json["sp_binding"]),
    "defaultRelayState": !exists(json, "default_relay_state") ? void 0 : json["default_relay_state"],
    "urlDownloadMetadata": json["url_download_metadata"],
    "urlSsoPost": json["url_sso_post"],
    "urlSsoRedirect": json["url_sso_redirect"],
    "urlSsoInit": json["url_sso_init"],
    "urlSloPost": json["url_slo_post"],
    "urlSloRedirect": json["url_slo_redirect"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSAMLProviderList.js
function PaginatedSAMLProviderListFromJSON(json) {
  return PaginatedSAMLProviderListFromJSONTyped(json, false);
}
function PaginatedSAMLProviderListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SAMLProviderFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMProviderGroup.js
function SCIMProviderGroupFromJSON(json) {
  return SCIMProviderGroupFromJSONTyped(json, false);
}
function SCIMProviderGroupFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "id": json["id"],
    "scimId": json["scim_id"],
    "group": json["group"],
    "groupObj": UserGroupFromJSON(json["group_obj"]),
    "provider": json["provider"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSCIMProviderGroupList.js
function PaginatedSCIMProviderGroupListFromJSON(json) {
  return PaginatedSCIMProviderGroupListFromJSONTyped(json, false);
}
function PaginatedSCIMProviderGroupListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SCIMProviderGroupFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMProvider.js
function SCIMProviderFromJSON(json) {
  return SCIMProviderFromJSONTyped(json, false);
}
function SCIMProviderFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "propertyMappings": !exists(json, "property_mappings") ? void 0 : json["property_mappings"],
    "propertyMappingsGroup": !exists(json, "property_mappings_group") ? void 0 : json["property_mappings_group"],
    "component": json["component"],
    "assignedBackchannelApplicationSlug": json["assigned_backchannel_application_slug"],
    "assignedBackchannelApplicationName": json["assigned_backchannel_application_name"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "url": json["url"],
    "verifyCertificates": !exists(json, "verify_certificates") ? void 0 : json["verify_certificates"],
    "token": json["token"],
    "excludeUsersServiceAccount": !exists(json, "exclude_users_service_account") ? void 0 : json["exclude_users_service_account"],
    "filterGroup": !exists(json, "filter_group") ? void 0 : json["filter_group"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSCIMProviderList.js
function PaginatedSCIMProviderListFromJSON(json) {
  return PaginatedSCIMProviderListFromJSONTyped(json, false);
}
function PaginatedSCIMProviderListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SCIMProviderFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMProviderUser.js
function SCIMProviderUserFromJSON(json) {
  return SCIMProviderUserFromJSONTyped(json, false);
}
function SCIMProviderUserFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "id": json["id"],
    "scimId": json["scim_id"],
    "user": json["user"],
    "userObj": GroupMemberFromJSON(json["user_obj"]),
    "provider": json["provider"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSCIMProviderUserList.js
function PaginatedSCIMProviderUserListFromJSON(json) {
  return PaginatedSCIMProviderUserListFromJSONTyped(json, false);
}
function PaginatedSCIMProviderUserListFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SCIMProviderUserFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedGoogleWorkspaceProviderRequest.js
function PatchedGoogleWorkspaceProviderRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "property_mappings": value.propertyMappings,
    "property_mappings_group": value.propertyMappingsGroup,
    "delegated_subject": value.delegatedSubject,
    "credentials": value.credentials,
    "scopes": value.scopes,
    "exclude_users_service_account": value.excludeUsersServiceAccount,
    "filter_group": value.filterGroup,
    "user_delete_action": OutgoingSyncDeleteActionToJSON(value.userDeleteAction),
    "group_delete_action": OutgoingSyncDeleteActionToJSON(value.groupDeleteAction),
    "default_group_email_domain": value.defaultGroupEmailDomain
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedLDAPProviderRequest.js
function PatchedLDAPProviderRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "authentication_flow": value.authenticationFlow,
    "authorization_flow": value.authorizationFlow,
    "invalidation_flow": value.invalidationFlow,
    "property_mappings": value.propertyMappings,
    "base_dn": value.baseDn,
    "certificate": value.certificate,
    "tls_server_name": value.tlsServerName,
    "uid_start_number": value.uidStartNumber,
    "gid_start_number": value.gidStartNumber,
    "search_mode": LDAPAPIAccessModeToJSON(value.searchMode),
    "bind_mode": LDAPAPIAccessModeToJSON(value.bindMode),
    "mfa_support": value.mfaSupport
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedMicrosoftEntraProviderRequest.js
function PatchedMicrosoftEntraProviderRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "property_mappings": value.propertyMappings,
    "property_mappings_group": value.propertyMappingsGroup,
    "client_id": value.clientId,
    "client_secret": value.clientSecret,
    "tenant_id": value.tenantId,
    "exclude_users_service_account": value.excludeUsersServiceAccount,
    "filter_group": value.filterGroup,
    "user_delete_action": OutgoingSyncDeleteActionToJSON(value.userDeleteAction),
    "group_delete_action": OutgoingSyncDeleteActionToJSON(value.groupDeleteAction)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedOAuth2ProviderRequest.js
function PatchedOAuth2ProviderRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "authentication_flow": value.authenticationFlow,
    "authorization_flow": value.authorizationFlow,
    "invalidation_flow": value.invalidationFlow,
    "property_mappings": value.propertyMappings,
    "client_type": ClientTypeEnumToJSON(value.clientType),
    "client_id": value.clientId,
    "client_secret": value.clientSecret,
    "access_code_validity": value.accessCodeValidity,
    "access_token_validity": value.accessTokenValidity,
    "refresh_token_validity": value.refreshTokenValidity,
    "include_claims_in_id_token": value.includeClaimsInIdToken,
    "signing_key": value.signingKey,
    "encryption_key": value.encryptionKey,
    "redirect_uris": value.redirectUris === void 0 ? void 0 : value.redirectUris.map(RedirectURIRequestToJSON),
    "sub_mode": SubModeEnumToJSON(value.subMode),
    "issuer_mode": IssuerModeEnumToJSON(value.issuerMode),
    "jwks_sources": value.jwksSources
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedProxyProviderRequest.js
function PatchedProxyProviderRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "authentication_flow": value.authenticationFlow,
    "authorization_flow": value.authorizationFlow,
    "invalidation_flow": value.invalidationFlow,
    "property_mappings": value.propertyMappings,
    "internal_host": value.internalHost,
    "external_host": value.externalHost,
    "internal_host_ssl_validation": value.internalHostSslValidation,
    "certificate": value.certificate,
    "skip_path_regex": value.skipPathRegex,
    "basic_auth_enabled": value.basicAuthEnabled,
    "basic_auth_password_attribute": value.basicAuthPasswordAttribute,
    "basic_auth_user_attribute": value.basicAuthUserAttribute,
    "mode": ProxyModeToJSON(value.mode),
    "intercept_header_auth": value.interceptHeaderAuth,
    "cookie_domain": value.cookieDomain,
    "jwks_sources": value.jwksSources,
    "access_token_validity": value.accessTokenValidity,
    "refresh_token_validity": value.refreshTokenValidity
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedRACProviderRequest.js
function PatchedRACProviderRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "authentication_flow": value.authenticationFlow,
    "authorization_flow": value.authorizationFlow,
    "property_mappings": value.propertyMappings,
    "settings": value.settings,
    "connection_expiry": value.connectionExpiry,
    "delete_token_on_disconnect": value.deleteTokenOnDisconnect
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedRadiusProviderRequest.js
function PatchedRadiusProviderRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "authentication_flow": value.authenticationFlow,
    "authorization_flow": value.authorizationFlow,
    "invalidation_flow": value.invalidationFlow,
    "property_mappings": value.propertyMappings,
    "client_networks": value.clientNetworks,
    "shared_secret": value.sharedSecret,
    "mfa_support": value.mfaSupport
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedSAMLProviderRequest.js
function PatchedSAMLProviderRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "authentication_flow": value.authenticationFlow,
    "authorization_flow": value.authorizationFlow,
    "invalidation_flow": value.invalidationFlow,
    "property_mappings": value.propertyMappings,
    "acs_url": value.acsUrl,
    "audience": value.audience,
    "issuer": value.issuer,
    "assertion_valid_not_before": value.assertionValidNotBefore,
    "assertion_valid_not_on_or_after": value.assertionValidNotOnOrAfter,
    "session_valid_not_on_or_after": value.sessionValidNotOnOrAfter,
    "name_id_mapping": value.nameIdMapping,
    "digest_algorithm": DigestAlgorithmEnumToJSON(value.digestAlgorithm),
    "signature_algorithm": SignatureAlgorithmEnumToJSON(value.signatureAlgorithm),
    "signing_kp": value.signingKp,
    "verification_kp": value.verificationKp,
    "encryption_kp": value.encryptionKp,
    "sign_assertion": value.signAssertion,
    "sign_response": value.signResponse,
    "sp_binding": SpBindingEnumToJSON(value.spBinding),
    "default_relay_state": value.defaultRelayState
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedSCIMProviderRequest.js
function PatchedSCIMProviderRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "name": value.name,
    "property_mappings": value.propertyMappings,
    "property_mappings_group": value.propertyMappingsGroup,
    "url": value.url,
    "verify_certificates": value.verifyCertificates,
    "token": value.token,
    "exclude_users_service_account": value.excludeUsersServiceAccount,
    "filter_group": value.filterGroup
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PropertyMappingPreview.js
function PropertyMappingPreviewFromJSON(json) {
  return PropertyMappingPreviewFromJSONTyped(json, false);
}
function PropertyMappingPreviewFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "preview": json["preview"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMProviderGroupRequest.js
function SCIMProviderGroupRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "scim_id": value.scimId,
    "group": value.group,
    "provider": value.provider
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SCIMProviderUserRequest.js
function SCIMProviderUserRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "scim_id": value.scimId,
    "user": value.user,
    "provider": value.provider
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SyncObjectModelEnum.js
var SyncObjectModelEnum = {
  User: "authentik.core.models.User",
  Group: "authentik.core.models.Group",
  UnknownDefaultOpenApi: "11184809"
};
function SyncObjectModelEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/SyncObjectRequest.js
function SyncObjectRequestToJSON(value) {
  if (value === void 0) {
    return void 0;
  }
  if (value === null) {
    return null;
  }
  return {
    "sync_object_model": SyncObjectModelEnumToJSON(value.syncObjectModel),
    "sync_object_id": value.syncObjectId
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SyncObjectResult.js
function SyncObjectResultFromJSON(json) {
  return SyncObjectResultFromJSONTyped(json, false);
}
function SyncObjectResultFromJSONTyped(json, ignoreDiscriminator) {
  if (json === void 0 || json === null) {
    return json;
  }
  return {
    "messages": json["messages"].map(LogEventFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/apis/ProvidersApi.js
var __awaiter = function(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var ProvidersApi = class extends BaseAPI {
  /**
   * Provider Viewset
   */
  providersAllDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersAllDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/all/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Provider Viewset
   */
  providersAllDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersAllDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Provider Viewset
   */
  providersAllListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.applicationIsnull !== void 0) {
        queryParameters["application__isnull"] = requestParameters.applicationIsnull;
      }
      if (requestParameters.backchannel !== void 0) {
        queryParameters["backchannel"] = requestParameters.backchannel;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/all/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedProviderListFromJSON(jsonValue));
    });
  }
  /**
   * Provider Viewset
   */
  providersAllList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersAllListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Provider Viewset
   */
  providersAllRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersAllRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/all/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ProviderFromJSON(jsonValue));
    });
  }
  /**
   * Provider Viewset
   */
  providersAllRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersAllRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get all creatable types
   */
  providersAllTypesListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/all/types/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(TypeCreateFromJSON));
    });
  }
  /**
   * Get all creatable types
   */
  providersAllTypesList(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersAllTypesListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersAllUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersAllUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/all/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersAllUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersAllUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GoogleWorkspaceProvider Viewset
   */
  providersGoogleWorkspaceCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.googleWorkspaceProviderRequest === null || requestParameters.googleWorkspaceProviderRequest === void 0) {
        throw new RequiredError("googleWorkspaceProviderRequest", "Required parameter requestParameters.googleWorkspaceProviderRequest was null or undefined when calling providersGoogleWorkspaceCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: GoogleWorkspaceProviderRequestToJSON(requestParameters.googleWorkspaceProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => GoogleWorkspaceProviderFromJSON(jsonValue));
    });
  }
  /**
   * GoogleWorkspaceProvider Viewset
   */
  providersGoogleWorkspaceCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersGoogleWorkspaceCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GoogleWorkspaceProvider Viewset
   */
  providersGoogleWorkspaceDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersGoogleWorkspaceDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * GoogleWorkspaceProvider Viewset
   */
  providersGoogleWorkspaceDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersGoogleWorkspaceDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * GoogleWorkspaceProviderGroup Viewset
   */
  providersGoogleWorkspaceGroupsCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.googleWorkspaceProviderGroupRequest === null || requestParameters.googleWorkspaceProviderGroupRequest === void 0) {
        throw new RequiredError("googleWorkspaceProviderGroupRequest", "Required parameter requestParameters.googleWorkspaceProviderGroupRequest was null or undefined when calling providersGoogleWorkspaceGroupsCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace_groups/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: GoogleWorkspaceProviderGroupRequestToJSON(requestParameters.googleWorkspaceProviderGroupRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => GoogleWorkspaceProviderGroupFromJSON(jsonValue));
    });
  }
  /**
   * GoogleWorkspaceProviderGroup Viewset
   */
  providersGoogleWorkspaceGroupsCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersGoogleWorkspaceGroupsCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GoogleWorkspaceProviderGroup Viewset
   */
  providersGoogleWorkspaceGroupsDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersGoogleWorkspaceGroupsDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace_groups/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * GoogleWorkspaceProviderGroup Viewset
   */
  providersGoogleWorkspaceGroupsDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersGoogleWorkspaceGroupsDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * GoogleWorkspaceProviderGroup Viewset
   */
  providersGoogleWorkspaceGroupsListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.groupGroupUuid !== void 0) {
        queryParameters["group__group_uuid"] = requestParameters.groupGroupUuid;
      }
      if (requestParameters.groupName !== void 0) {
        queryParameters["group__name"] = requestParameters.groupName;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.providerId !== void 0) {
        queryParameters["provider__id"] = requestParameters.providerId;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace_groups/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedGoogleWorkspaceProviderGroupListFromJSON(jsonValue));
    });
  }
  /**
   * GoogleWorkspaceProviderGroup Viewset
   */
  providersGoogleWorkspaceGroupsList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersGoogleWorkspaceGroupsListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GoogleWorkspaceProviderGroup Viewset
   */
  providersGoogleWorkspaceGroupsRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersGoogleWorkspaceGroupsRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace_groups/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => GoogleWorkspaceProviderGroupFromJSON(jsonValue));
    });
  }
  /**
   * GoogleWorkspaceProviderGroup Viewset
   */
  providersGoogleWorkspaceGroupsRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersGoogleWorkspaceGroupsRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersGoogleWorkspaceGroupsUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersGoogleWorkspaceGroupsUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace_groups/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersGoogleWorkspaceGroupsUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersGoogleWorkspaceGroupsUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GoogleWorkspaceProvider Viewset
   */
  providersGoogleWorkspaceListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.delegatedSubject !== void 0) {
        queryParameters["delegated_subject"] = requestParameters.delegatedSubject;
      }
      if (requestParameters.excludeUsersServiceAccount !== void 0) {
        queryParameters["exclude_users_service_account"] = requestParameters.excludeUsersServiceAccount;
      }
      if (requestParameters.filterGroup !== void 0) {
        queryParameters["filter_group"] = requestParameters.filterGroup;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedGoogleWorkspaceProviderListFromJSON(jsonValue));
    });
  }
  /**
   * GoogleWorkspaceProvider Viewset
   */
  providersGoogleWorkspaceList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersGoogleWorkspaceListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GoogleWorkspaceProvider Viewset
   */
  providersGoogleWorkspacePartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersGoogleWorkspacePartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedGoogleWorkspaceProviderRequestToJSON(requestParameters.patchedGoogleWorkspaceProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => GoogleWorkspaceProviderFromJSON(jsonValue));
    });
  }
  /**
   * GoogleWorkspaceProvider Viewset
   */
  providersGoogleWorkspacePartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersGoogleWorkspacePartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GoogleWorkspaceProvider Viewset
   */
  providersGoogleWorkspaceRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersGoogleWorkspaceRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => GoogleWorkspaceProviderFromJSON(jsonValue));
    });
  }
  /**
   * GoogleWorkspaceProvider Viewset
   */
  providersGoogleWorkspaceRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersGoogleWorkspaceRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Sync/Re-sync a single user/group object
   */
  providersGoogleWorkspaceSyncObjectCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersGoogleWorkspaceSyncObjectCreate.");
      }
      if (requestParameters.syncObjectRequest === null || requestParameters.syncObjectRequest === void 0) {
        throw new RequiredError("syncObjectRequest", "Required parameter requestParameters.syncObjectRequest was null or undefined when calling providersGoogleWorkspaceSyncObjectCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace/{id}/sync/object/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SyncObjectRequestToJSON(requestParameters.syncObjectRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SyncObjectResultFromJSON(jsonValue));
    });
  }
  /**
   * Sync/Re-sync a single user/group object
   */
  providersGoogleWorkspaceSyncObjectCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersGoogleWorkspaceSyncObjectCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get provider\'s sync status
   */
  providersGoogleWorkspaceSyncStatusRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersGoogleWorkspaceSyncStatusRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace/{id}/sync/status/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SyncStatusFromJSON(jsonValue));
    });
  }
  /**
   * Get provider\'s sync status
   */
  providersGoogleWorkspaceSyncStatusRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersGoogleWorkspaceSyncStatusRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GoogleWorkspaceProvider Viewset
   */
  providersGoogleWorkspaceUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersGoogleWorkspaceUpdate.");
      }
      if (requestParameters.googleWorkspaceProviderRequest === null || requestParameters.googleWorkspaceProviderRequest === void 0) {
        throw new RequiredError("googleWorkspaceProviderRequest", "Required parameter requestParameters.googleWorkspaceProviderRequest was null or undefined when calling providersGoogleWorkspaceUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: GoogleWorkspaceProviderRequestToJSON(requestParameters.googleWorkspaceProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => GoogleWorkspaceProviderFromJSON(jsonValue));
    });
  }
  /**
   * GoogleWorkspaceProvider Viewset
   */
  providersGoogleWorkspaceUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersGoogleWorkspaceUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersGoogleWorkspaceUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersGoogleWorkspaceUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersGoogleWorkspaceUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersGoogleWorkspaceUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GoogleWorkspaceProviderUser Viewset
   */
  providersGoogleWorkspaceUsersCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.googleWorkspaceProviderUserRequest === null || requestParameters.googleWorkspaceProviderUserRequest === void 0) {
        throw new RequiredError("googleWorkspaceProviderUserRequest", "Required parameter requestParameters.googleWorkspaceProviderUserRequest was null or undefined when calling providersGoogleWorkspaceUsersCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace_users/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: GoogleWorkspaceProviderUserRequestToJSON(requestParameters.googleWorkspaceProviderUserRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => GoogleWorkspaceProviderUserFromJSON(jsonValue));
    });
  }
  /**
   * GoogleWorkspaceProviderUser Viewset
   */
  providersGoogleWorkspaceUsersCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersGoogleWorkspaceUsersCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GoogleWorkspaceProviderUser Viewset
   */
  providersGoogleWorkspaceUsersDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersGoogleWorkspaceUsersDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace_users/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * GoogleWorkspaceProviderUser Viewset
   */
  providersGoogleWorkspaceUsersDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersGoogleWorkspaceUsersDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * GoogleWorkspaceProviderUser Viewset
   */
  providersGoogleWorkspaceUsersListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.providerId !== void 0) {
        queryParameters["provider__id"] = requestParameters.providerId;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.userId !== void 0) {
        queryParameters["user__id"] = requestParameters.userId;
      }
      if (requestParameters.userUsername !== void 0) {
        queryParameters["user__username"] = requestParameters.userUsername;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace_users/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedGoogleWorkspaceProviderUserListFromJSON(jsonValue));
    });
  }
  /**
   * GoogleWorkspaceProviderUser Viewset
   */
  providersGoogleWorkspaceUsersList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersGoogleWorkspaceUsersListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GoogleWorkspaceProviderUser Viewset
   */
  providersGoogleWorkspaceUsersRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersGoogleWorkspaceUsersRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace_users/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => GoogleWorkspaceProviderUserFromJSON(jsonValue));
    });
  }
  /**
   * GoogleWorkspaceProviderUser Viewset
   */
  providersGoogleWorkspaceUsersRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersGoogleWorkspaceUsersRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersGoogleWorkspaceUsersUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersGoogleWorkspaceUsersUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/google_workspace_users/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersGoogleWorkspaceUsersUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersGoogleWorkspaceUsersUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAPProvider Viewset
   */
  providersLdapCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.lDAPProviderRequest === null || requestParameters.lDAPProviderRequest === void 0) {
        throw new RequiredError("lDAPProviderRequest", "Required parameter requestParameters.lDAPProviderRequest was null or undefined when calling providersLdapCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/ldap/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: LDAPProviderRequestToJSON(requestParameters.lDAPProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPProviderFromJSON(jsonValue));
    });
  }
  /**
   * LDAPProvider Viewset
   */
  providersLdapCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersLdapCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAPProvider Viewset
   */
  providersLdapDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersLdapDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/ldap/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * LDAPProvider Viewset
   */
  providersLdapDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersLdapDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * LDAPProvider Viewset
   */
  providersLdapListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.applicationIsnull !== void 0) {
        queryParameters["application__isnull"] = requestParameters.applicationIsnull;
      }
      if (requestParameters.authorizationFlowSlugIexact !== void 0) {
        queryParameters["authorization_flow__slug__iexact"] = requestParameters.authorizationFlowSlugIexact;
      }
      if (requestParameters.baseDnIexact !== void 0) {
        queryParameters["base_dn__iexact"] = requestParameters.baseDnIexact;
      }
      if (requestParameters.certificateKpUuidIexact !== void 0) {
        queryParameters["certificate__kp_uuid__iexact"] = requestParameters.certificateKpUuidIexact;
      }
      if (requestParameters.certificateNameIexact !== void 0) {
        queryParameters["certificate__name__iexact"] = requestParameters.certificateNameIexact;
      }
      if (requestParameters.gidStartNumberIexact !== void 0) {
        queryParameters["gid_start_number__iexact"] = requestParameters.gidStartNumberIexact;
      }
      if (requestParameters.nameIexact !== void 0) {
        queryParameters["name__iexact"] = requestParameters.nameIexact;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.tlsServerNameIexact !== void 0) {
        queryParameters["tls_server_name__iexact"] = requestParameters.tlsServerNameIexact;
      }
      if (requestParameters.uidStartNumberIexact !== void 0) {
        queryParameters["uid_start_number__iexact"] = requestParameters.uidStartNumberIexact;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/ldap/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedLDAPProviderListFromJSON(jsonValue));
    });
  }
  /**
   * LDAPProvider Viewset
   */
  providersLdapList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersLdapListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAPProvider Viewset
   */
  providersLdapPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersLdapPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/ldap/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedLDAPProviderRequestToJSON(requestParameters.patchedLDAPProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPProviderFromJSON(jsonValue));
    });
  }
  /**
   * LDAPProvider Viewset
   */
  providersLdapPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersLdapPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAPProvider Viewset
   */
  providersLdapRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersLdapRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/ldap/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPProviderFromJSON(jsonValue));
    });
  }
  /**
   * LDAPProvider Viewset
   */
  providersLdapRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersLdapRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * LDAPProvider Viewset
   */
  providersLdapUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersLdapUpdate.");
      }
      if (requestParameters.lDAPProviderRequest === null || requestParameters.lDAPProviderRequest === void 0) {
        throw new RequiredError("lDAPProviderRequest", "Required parameter requestParameters.lDAPProviderRequest was null or undefined when calling providersLdapUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/ldap/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: LDAPProviderRequestToJSON(requestParameters.lDAPProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LDAPProviderFromJSON(jsonValue));
    });
  }
  /**
   * LDAPProvider Viewset
   */
  providersLdapUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersLdapUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersLdapUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersLdapUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/ldap/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersLdapUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersLdapUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * MicrosoftEntraProvider Viewset
   */
  providersMicrosoftEntraCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.microsoftEntraProviderRequest === null || requestParameters.microsoftEntraProviderRequest === void 0) {
        throw new RequiredError("microsoftEntraProviderRequest", "Required parameter requestParameters.microsoftEntraProviderRequest was null or undefined when calling providersMicrosoftEntraCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: MicrosoftEntraProviderRequestToJSON(requestParameters.microsoftEntraProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => MicrosoftEntraProviderFromJSON(jsonValue));
    });
  }
  /**
   * MicrosoftEntraProvider Viewset
   */
  providersMicrosoftEntraCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersMicrosoftEntraCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * MicrosoftEntraProvider Viewset
   */
  providersMicrosoftEntraDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersMicrosoftEntraDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * MicrosoftEntraProvider Viewset
   */
  providersMicrosoftEntraDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersMicrosoftEntraDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * MicrosoftEntraProviderGroup Viewset
   */
  providersMicrosoftEntraGroupsCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.microsoftEntraProviderGroupRequest === null || requestParameters.microsoftEntraProviderGroupRequest === void 0) {
        throw new RequiredError("microsoftEntraProviderGroupRequest", "Required parameter requestParameters.microsoftEntraProviderGroupRequest was null or undefined when calling providersMicrosoftEntraGroupsCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra_groups/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: MicrosoftEntraProviderGroupRequestToJSON(requestParameters.microsoftEntraProviderGroupRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => MicrosoftEntraProviderGroupFromJSON(jsonValue));
    });
  }
  /**
   * MicrosoftEntraProviderGroup Viewset
   */
  providersMicrosoftEntraGroupsCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersMicrosoftEntraGroupsCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * MicrosoftEntraProviderGroup Viewset
   */
  providersMicrosoftEntraGroupsDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersMicrosoftEntraGroupsDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra_groups/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * MicrosoftEntraProviderGroup Viewset
   */
  providersMicrosoftEntraGroupsDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersMicrosoftEntraGroupsDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * MicrosoftEntraProviderGroup Viewset
   */
  providersMicrosoftEntraGroupsListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.groupGroupUuid !== void 0) {
        queryParameters["group__group_uuid"] = requestParameters.groupGroupUuid;
      }
      if (requestParameters.groupName !== void 0) {
        queryParameters["group__name"] = requestParameters.groupName;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.providerId !== void 0) {
        queryParameters["provider__id"] = requestParameters.providerId;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra_groups/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedMicrosoftEntraProviderGroupListFromJSON(jsonValue));
    });
  }
  /**
   * MicrosoftEntraProviderGroup Viewset
   */
  providersMicrosoftEntraGroupsList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersMicrosoftEntraGroupsListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * MicrosoftEntraProviderGroup Viewset
   */
  providersMicrosoftEntraGroupsRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersMicrosoftEntraGroupsRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra_groups/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => MicrosoftEntraProviderGroupFromJSON(jsonValue));
    });
  }
  /**
   * MicrosoftEntraProviderGroup Viewset
   */
  providersMicrosoftEntraGroupsRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersMicrosoftEntraGroupsRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersMicrosoftEntraGroupsUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersMicrosoftEntraGroupsUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra_groups/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersMicrosoftEntraGroupsUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersMicrosoftEntraGroupsUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * MicrosoftEntraProvider Viewset
   */
  providersMicrosoftEntraListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.excludeUsersServiceAccount !== void 0) {
        queryParameters["exclude_users_service_account"] = requestParameters.excludeUsersServiceAccount;
      }
      if (requestParameters.filterGroup !== void 0) {
        queryParameters["filter_group"] = requestParameters.filterGroup;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedMicrosoftEntraProviderListFromJSON(jsonValue));
    });
  }
  /**
   * MicrosoftEntraProvider Viewset
   */
  providersMicrosoftEntraList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersMicrosoftEntraListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * MicrosoftEntraProvider Viewset
   */
  providersMicrosoftEntraPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersMicrosoftEntraPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedMicrosoftEntraProviderRequestToJSON(requestParameters.patchedMicrosoftEntraProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => MicrosoftEntraProviderFromJSON(jsonValue));
    });
  }
  /**
   * MicrosoftEntraProvider Viewset
   */
  providersMicrosoftEntraPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersMicrosoftEntraPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * MicrosoftEntraProvider Viewset
   */
  providersMicrosoftEntraRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersMicrosoftEntraRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => MicrosoftEntraProviderFromJSON(jsonValue));
    });
  }
  /**
   * MicrosoftEntraProvider Viewset
   */
  providersMicrosoftEntraRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersMicrosoftEntraRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Sync/Re-sync a single user/group object
   */
  providersMicrosoftEntraSyncObjectCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersMicrosoftEntraSyncObjectCreate.");
      }
      if (requestParameters.syncObjectRequest === null || requestParameters.syncObjectRequest === void 0) {
        throw new RequiredError("syncObjectRequest", "Required parameter requestParameters.syncObjectRequest was null or undefined when calling providersMicrosoftEntraSyncObjectCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra/{id}/sync/object/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SyncObjectRequestToJSON(requestParameters.syncObjectRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SyncObjectResultFromJSON(jsonValue));
    });
  }
  /**
   * Sync/Re-sync a single user/group object
   */
  providersMicrosoftEntraSyncObjectCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersMicrosoftEntraSyncObjectCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get provider\'s sync status
   */
  providersMicrosoftEntraSyncStatusRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersMicrosoftEntraSyncStatusRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra/{id}/sync/status/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SyncStatusFromJSON(jsonValue));
    });
  }
  /**
   * Get provider\'s sync status
   */
  providersMicrosoftEntraSyncStatusRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersMicrosoftEntraSyncStatusRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * MicrosoftEntraProvider Viewset
   */
  providersMicrosoftEntraUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersMicrosoftEntraUpdate.");
      }
      if (requestParameters.microsoftEntraProviderRequest === null || requestParameters.microsoftEntraProviderRequest === void 0) {
        throw new RequiredError("microsoftEntraProviderRequest", "Required parameter requestParameters.microsoftEntraProviderRequest was null or undefined when calling providersMicrosoftEntraUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: MicrosoftEntraProviderRequestToJSON(requestParameters.microsoftEntraProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => MicrosoftEntraProviderFromJSON(jsonValue));
    });
  }
  /**
   * MicrosoftEntraProvider Viewset
   */
  providersMicrosoftEntraUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersMicrosoftEntraUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersMicrosoftEntraUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersMicrosoftEntraUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersMicrosoftEntraUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersMicrosoftEntraUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * MicrosoftEntraProviderUser Viewset
   */
  providersMicrosoftEntraUsersCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.microsoftEntraProviderUserRequest === null || requestParameters.microsoftEntraProviderUserRequest === void 0) {
        throw new RequiredError("microsoftEntraProviderUserRequest", "Required parameter requestParameters.microsoftEntraProviderUserRequest was null or undefined when calling providersMicrosoftEntraUsersCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra_users/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: MicrosoftEntraProviderUserRequestToJSON(requestParameters.microsoftEntraProviderUserRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => MicrosoftEntraProviderUserFromJSON(jsonValue));
    });
  }
  /**
   * MicrosoftEntraProviderUser Viewset
   */
  providersMicrosoftEntraUsersCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersMicrosoftEntraUsersCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * MicrosoftEntraProviderUser Viewset
   */
  providersMicrosoftEntraUsersDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersMicrosoftEntraUsersDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra_users/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * MicrosoftEntraProviderUser Viewset
   */
  providersMicrosoftEntraUsersDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersMicrosoftEntraUsersDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * MicrosoftEntraProviderUser Viewset
   */
  providersMicrosoftEntraUsersListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.providerId !== void 0) {
        queryParameters["provider__id"] = requestParameters.providerId;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.userId !== void 0) {
        queryParameters["user__id"] = requestParameters.userId;
      }
      if (requestParameters.userUsername !== void 0) {
        queryParameters["user__username"] = requestParameters.userUsername;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra_users/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedMicrosoftEntraProviderUserListFromJSON(jsonValue));
    });
  }
  /**
   * MicrosoftEntraProviderUser Viewset
   */
  providersMicrosoftEntraUsersList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersMicrosoftEntraUsersListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * MicrosoftEntraProviderUser Viewset
   */
  providersMicrosoftEntraUsersRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersMicrosoftEntraUsersRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra_users/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => MicrosoftEntraProviderUserFromJSON(jsonValue));
    });
  }
  /**
   * MicrosoftEntraProviderUser Viewset
   */
  providersMicrosoftEntraUsersRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersMicrosoftEntraUsersRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersMicrosoftEntraUsersUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersMicrosoftEntraUsersUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/microsoft_entra_users/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersMicrosoftEntraUsersUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersMicrosoftEntraUsersUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * OAuth2Provider Viewset
   */
  providersOauth2CreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.oAuth2ProviderRequest === null || requestParameters.oAuth2ProviderRequest === void 0) {
        throw new RequiredError("oAuth2ProviderRequest", "Required parameter requestParameters.oAuth2ProviderRequest was null or undefined when calling providersOauth2Create.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/oauth2/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: OAuth2ProviderRequestToJSON(requestParameters.oAuth2ProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OAuth2ProviderFromJSON(jsonValue));
    });
  }
  /**
   * OAuth2Provider Viewset
   */
  providersOauth2Create(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersOauth2CreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * OAuth2Provider Viewset
   */
  providersOauth2DestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersOauth2Destroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/oauth2/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * OAuth2Provider Viewset
   */
  providersOauth2Destroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersOauth2DestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * OAuth2Provider Viewset
   */
  providersOauth2ListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.accessCodeValidity !== void 0) {
        queryParameters["access_code_validity"] = requestParameters.accessCodeValidity;
      }
      if (requestParameters.accessTokenValidity !== void 0) {
        queryParameters["access_token_validity"] = requestParameters.accessTokenValidity;
      }
      if (requestParameters.application !== void 0) {
        queryParameters["application"] = requestParameters.application;
      }
      if (requestParameters.authorizationFlow !== void 0) {
        queryParameters["authorization_flow"] = requestParameters.authorizationFlow;
      }
      if (requestParameters.clientId !== void 0) {
        queryParameters["client_id"] = requestParameters.clientId;
      }
      if (requestParameters.clientType !== void 0) {
        queryParameters["client_type"] = requestParameters.clientType;
      }
      if (requestParameters.includeClaimsInIdToken !== void 0) {
        queryParameters["include_claims_in_id_token"] = requestParameters.includeClaimsInIdToken;
      }
      if (requestParameters.issuerMode !== void 0) {
        queryParameters["issuer_mode"] = requestParameters.issuerMode;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.propertyMappings) {
        queryParameters["property_mappings"] = requestParameters.propertyMappings;
      }
      if (requestParameters.refreshTokenValidity !== void 0) {
        queryParameters["refresh_token_validity"] = requestParameters.refreshTokenValidity;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.signingKey !== void 0) {
        queryParameters["signing_key"] = requestParameters.signingKey;
      }
      if (requestParameters.subMode !== void 0) {
        queryParameters["sub_mode"] = requestParameters.subMode;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/oauth2/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedOAuth2ProviderListFromJSON(jsonValue));
    });
  }
  /**
   * OAuth2Provider Viewset
   */
  providersOauth2List(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersOauth2ListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * OAuth2Provider Viewset
   */
  providersOauth2PartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersOauth2PartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/oauth2/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedOAuth2ProviderRequestToJSON(requestParameters.patchedOAuth2ProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OAuth2ProviderFromJSON(jsonValue));
    });
  }
  /**
   * OAuth2Provider Viewset
   */
  providersOauth2PartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersOauth2PartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Preview user data for provider
   */
  providersOauth2PreviewUserRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersOauth2PreviewUserRetrieve.");
      }
      const queryParameters = {};
      if (requestParameters.forUser !== void 0) {
        queryParameters["for_user"] = requestParameters.forUser;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/oauth2/{id}/preview_user/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PropertyMappingPreviewFromJSON(jsonValue));
    });
  }
  /**
   * Preview user data for provider
   */
  providersOauth2PreviewUserRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersOauth2PreviewUserRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * OAuth2Provider Viewset
   */
  providersOauth2RetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersOauth2Retrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/oauth2/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OAuth2ProviderFromJSON(jsonValue));
    });
  }
  /**
   * OAuth2Provider Viewset
   */
  providersOauth2Retrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersOauth2RetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get Providers setup URLs
   */
  providersOauth2SetupUrlsRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersOauth2SetupUrlsRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/oauth2/{id}/setup_urls/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OAuth2ProviderSetupURLsFromJSON(jsonValue));
    });
  }
  /**
   * Get Providers setup URLs
   */
  providersOauth2SetupUrlsRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersOauth2SetupUrlsRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * OAuth2Provider Viewset
   */
  providersOauth2UpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersOauth2Update.");
      }
      if (requestParameters.oAuth2ProviderRequest === null || requestParameters.oAuth2ProviderRequest === void 0) {
        throw new RequiredError("oAuth2ProviderRequest", "Required parameter requestParameters.oAuth2ProviderRequest was null or undefined when calling providersOauth2Update.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/oauth2/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: OAuth2ProviderRequestToJSON(requestParameters.oAuth2ProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => OAuth2ProviderFromJSON(jsonValue));
    });
  }
  /**
   * OAuth2Provider Viewset
   */
  providersOauth2Update(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersOauth2UpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersOauth2UsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersOauth2UsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/oauth2/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersOauth2UsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersOauth2UsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ProxyProvider Viewset
   */
  providersProxyCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.proxyProviderRequest === null || requestParameters.proxyProviderRequest === void 0) {
        throw new RequiredError("proxyProviderRequest", "Required parameter requestParameters.proxyProviderRequest was null or undefined when calling providersProxyCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/proxy/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: ProxyProviderRequestToJSON(requestParameters.proxyProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ProxyProviderFromJSON(jsonValue));
    });
  }
  /**
   * ProxyProvider Viewset
   */
  providersProxyCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersProxyCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ProxyProvider Viewset
   */
  providersProxyDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersProxyDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/proxy/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * ProxyProvider Viewset
   */
  providersProxyDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersProxyDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * ProxyProvider Viewset
   */
  providersProxyListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.applicationIsnull !== void 0) {
        queryParameters["application__isnull"] = requestParameters.applicationIsnull;
      }
      if (requestParameters.authorizationFlowSlugIexact !== void 0) {
        queryParameters["authorization_flow__slug__iexact"] = requestParameters.authorizationFlowSlugIexact;
      }
      if (requestParameters.basicAuthEnabledIexact !== void 0) {
        queryParameters["basic_auth_enabled__iexact"] = requestParameters.basicAuthEnabledIexact;
      }
      if (requestParameters.basicAuthPasswordAttributeIexact !== void 0) {
        queryParameters["basic_auth_password_attribute__iexact"] = requestParameters.basicAuthPasswordAttributeIexact;
      }
      if (requestParameters.basicAuthUserAttributeIexact !== void 0) {
        queryParameters["basic_auth_user_attribute__iexact"] = requestParameters.basicAuthUserAttributeIexact;
      }
      if (requestParameters.certificateKpUuidIexact !== void 0) {
        queryParameters["certificate__kp_uuid__iexact"] = requestParameters.certificateKpUuidIexact;
      }
      if (requestParameters.certificateNameIexact !== void 0) {
        queryParameters["certificate__name__iexact"] = requestParameters.certificateNameIexact;
      }
      if (requestParameters.cookieDomainIexact !== void 0) {
        queryParameters["cookie_domain__iexact"] = requestParameters.cookieDomainIexact;
      }
      if (requestParameters.externalHostIexact !== void 0) {
        queryParameters["external_host__iexact"] = requestParameters.externalHostIexact;
      }
      if (requestParameters.internalHostIexact !== void 0) {
        queryParameters["internal_host__iexact"] = requestParameters.internalHostIexact;
      }
      if (requestParameters.internalHostSslValidationIexact !== void 0) {
        queryParameters["internal_host_ssl_validation__iexact"] = requestParameters.internalHostSslValidationIexact;
      }
      if (requestParameters.modeIexact !== void 0) {
        queryParameters["mode__iexact"] = requestParameters.modeIexact;
      }
      if (requestParameters.nameIexact !== void 0) {
        queryParameters["name__iexact"] = requestParameters.nameIexact;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.propertyMappingsIexact) {
        queryParameters["property_mappings__iexact"] = requestParameters.propertyMappingsIexact;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.skipPathRegexIexact !== void 0) {
        queryParameters["skip_path_regex__iexact"] = requestParameters.skipPathRegexIexact;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/proxy/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedProxyProviderListFromJSON(jsonValue));
    });
  }
  /**
   * ProxyProvider Viewset
   */
  providersProxyList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersProxyListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ProxyProvider Viewset
   */
  providersProxyPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersProxyPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/proxy/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedProxyProviderRequestToJSON(requestParameters.patchedProxyProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ProxyProviderFromJSON(jsonValue));
    });
  }
  /**
   * ProxyProvider Viewset
   */
  providersProxyPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersProxyPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ProxyProvider Viewset
   */
  providersProxyRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersProxyRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/proxy/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ProxyProviderFromJSON(jsonValue));
    });
  }
  /**
   * ProxyProvider Viewset
   */
  providersProxyRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersProxyRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ProxyProvider Viewset
   */
  providersProxyUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersProxyUpdate.");
      }
      if (requestParameters.proxyProviderRequest === null || requestParameters.proxyProviderRequest === void 0) {
        throw new RequiredError("proxyProviderRequest", "Required parameter requestParameters.proxyProviderRequest was null or undefined when calling providersProxyUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/proxy/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: ProxyProviderRequestToJSON(requestParameters.proxyProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ProxyProviderFromJSON(jsonValue));
    });
  }
  /**
   * ProxyProvider Viewset
   */
  providersProxyUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersProxyUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersProxyUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersProxyUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/proxy/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersProxyUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersProxyUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RACProvider Viewset
   */
  providersRacCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.rACProviderRequest === null || requestParameters.rACProviderRequest === void 0) {
        throw new RequiredError("rACProviderRequest", "Required parameter requestParameters.rACProviderRequest was null or undefined when calling providersRacCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/rac/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: RACProviderRequestToJSON(requestParameters.rACProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RACProviderFromJSON(jsonValue));
    });
  }
  /**
   * RACProvider Viewset
   */
  providersRacCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersRacCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RACProvider Viewset
   */
  providersRacDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersRacDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/rac/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * RACProvider Viewset
   */
  providersRacDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersRacDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * RACProvider Viewset
   */
  providersRacListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.applicationIsnull !== void 0) {
        queryParameters["application__isnull"] = requestParameters.applicationIsnull;
      }
      if (requestParameters.nameIexact !== void 0) {
        queryParameters["name__iexact"] = requestParameters.nameIexact;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/rac/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedRACProviderListFromJSON(jsonValue));
    });
  }
  /**
   * RACProvider Viewset
   */
  providersRacList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersRacListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RACProvider Viewset
   */
  providersRacPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersRacPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/rac/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedRACProviderRequestToJSON(requestParameters.patchedRACProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RACProviderFromJSON(jsonValue));
    });
  }
  /**
   * RACProvider Viewset
   */
  providersRacPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersRacPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RACProvider Viewset
   */
  providersRacRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersRacRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/rac/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RACProviderFromJSON(jsonValue));
    });
  }
  /**
   * RACProvider Viewset
   */
  providersRacRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersRacRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RACProvider Viewset
   */
  providersRacUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersRacUpdate.");
      }
      if (requestParameters.rACProviderRequest === null || requestParameters.rACProviderRequest === void 0) {
        throw new RequiredError("rACProviderRequest", "Required parameter requestParameters.rACProviderRequest was null or undefined when calling providersRacUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/rac/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: RACProviderRequestToJSON(requestParameters.rACProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RACProviderFromJSON(jsonValue));
    });
  }
  /**
   * RACProvider Viewset
   */
  providersRacUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersRacUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersRacUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersRacUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/rac/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersRacUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersRacUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RadiusProvider Viewset
   */
  providersRadiusCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.radiusProviderRequest === null || requestParameters.radiusProviderRequest === void 0) {
        throw new RequiredError("radiusProviderRequest", "Required parameter requestParameters.radiusProviderRequest was null or undefined when calling providersRadiusCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/radius/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: RadiusProviderRequestToJSON(requestParameters.radiusProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RadiusProviderFromJSON(jsonValue));
    });
  }
  /**
   * RadiusProvider Viewset
   */
  providersRadiusCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersRadiusCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RadiusProvider Viewset
   */
  providersRadiusDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersRadiusDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/radius/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * RadiusProvider Viewset
   */
  providersRadiusDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersRadiusDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * RadiusProvider Viewset
   */
  providersRadiusListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.applicationIsnull !== void 0) {
        queryParameters["application__isnull"] = requestParameters.applicationIsnull;
      }
      if (requestParameters.authorizationFlowSlugIexact !== void 0) {
        queryParameters["authorization_flow__slug__iexact"] = requestParameters.authorizationFlowSlugIexact;
      }
      if (requestParameters.clientNetworksIexact !== void 0) {
        queryParameters["client_networks__iexact"] = requestParameters.clientNetworksIexact;
      }
      if (requestParameters.nameIexact !== void 0) {
        queryParameters["name__iexact"] = requestParameters.nameIexact;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/radius/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedRadiusProviderListFromJSON(jsonValue));
    });
  }
  /**
   * RadiusProvider Viewset
   */
  providersRadiusList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersRadiusListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RadiusProvider Viewset
   */
  providersRadiusPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersRadiusPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/radius/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedRadiusProviderRequestToJSON(requestParameters.patchedRadiusProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RadiusProviderFromJSON(jsonValue));
    });
  }
  /**
   * RadiusProvider Viewset
   */
  providersRadiusPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersRadiusPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RadiusProvider Viewset
   */
  providersRadiusRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersRadiusRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/radius/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RadiusProviderFromJSON(jsonValue));
    });
  }
  /**
   * RadiusProvider Viewset
   */
  providersRadiusRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersRadiusRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * RadiusProvider Viewset
   */
  providersRadiusUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersRadiusUpdate.");
      }
      if (requestParameters.radiusProviderRequest === null || requestParameters.radiusProviderRequest === void 0) {
        throw new RequiredError("radiusProviderRequest", "Required parameter requestParameters.radiusProviderRequest was null or undefined when calling providersRadiusUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/radius/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: RadiusProviderRequestToJSON(requestParameters.radiusProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RadiusProviderFromJSON(jsonValue));
    });
  }
  /**
   * RadiusProvider Viewset
   */
  providersRadiusUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersRadiusUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersRadiusUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersRadiusUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/radius/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersRadiusUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersRadiusUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLProvider Viewset
   */
  providersSamlCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.sAMLProviderRequest === null || requestParameters.sAMLProviderRequest === void 0) {
        throw new RequiredError("sAMLProviderRequest", "Required parameter requestParameters.sAMLProviderRequest was null or undefined when calling providersSamlCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/saml/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SAMLProviderRequestToJSON(requestParameters.sAMLProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLProviderFromJSON(jsonValue));
    });
  }
  /**
   * SAMLProvider Viewset
   */
  providersSamlCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersSamlCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLProvider Viewset
   */
  providersSamlDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersSamlDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/saml/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * SAMLProvider Viewset
   */
  providersSamlDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersSamlDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Create provider from SAML Metadata
   */
  providersSamlImportMetadataCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.name === null || requestParameters.name === void 0) {
        throw new RequiredError("name", "Required parameter requestParameters.name was null or undefined when calling providersSamlImportMetadataCreate.");
      }
      if (requestParameters.authorizationFlow === null || requestParameters.authorizationFlow === void 0) {
        throw new RequiredError("authorizationFlow", "Required parameter requestParameters.authorizationFlow was null or undefined when calling providersSamlImportMetadataCreate.");
      }
      if (requestParameters.invalidationFlow === null || requestParameters.invalidationFlow === void 0) {
        throw new RequiredError("invalidationFlow", "Required parameter requestParameters.invalidationFlow was null or undefined when calling providersSamlImportMetadataCreate.");
      }
      if (requestParameters.file === null || requestParameters.file === void 0) {
        throw new RequiredError("file", "Required parameter requestParameters.file was null or undefined when calling providersSamlImportMetadataCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const consumes = [
        { contentType: "multipart/form-data" }
      ];
      const canConsumeForm2 = canConsumeForm(consumes);
      let formParams;
      let useForm = false;
      useForm = canConsumeForm2;
      if (useForm) {
        formParams = new FormData();
      } else {
        formParams = new URLSearchParams();
      }
      if (requestParameters.name !== void 0) {
        formParams.append("name", requestParameters.name);
      }
      if (requestParameters.authorizationFlow !== void 0) {
        formParams.append("authorization_flow", requestParameters.authorizationFlow);
      }
      if (requestParameters.invalidationFlow !== void 0) {
        formParams.append("invalidation_flow", requestParameters.invalidationFlow);
      }
      if (requestParameters.file !== void 0) {
        formParams.append("file", requestParameters.file);
      }
      const response = yield this.request({
        path: `/providers/saml/import_metadata/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: formParams
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Create provider from SAML Metadata
   */
  providersSamlImportMetadataCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersSamlImportMetadataCreateRaw(requestParameters, initOverrides);
    });
  }
  /**
   * SAMLProvider Viewset
   */
  providersSamlListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.acsUrl !== void 0) {
        queryParameters["acs_url"] = requestParameters.acsUrl;
      }
      if (requestParameters.assertionValidNotBefore !== void 0) {
        queryParameters["assertion_valid_not_before"] = requestParameters.assertionValidNotBefore;
      }
      if (requestParameters.assertionValidNotOnOrAfter !== void 0) {
        queryParameters["assertion_valid_not_on_or_after"] = requestParameters.assertionValidNotOnOrAfter;
      }
      if (requestParameters.audience !== void 0) {
        queryParameters["audience"] = requestParameters.audience;
      }
      if (requestParameters.authenticationFlow !== void 0) {
        queryParameters["authentication_flow"] = requestParameters.authenticationFlow;
      }
      if (requestParameters.authorizationFlow !== void 0) {
        queryParameters["authorization_flow"] = requestParameters.authorizationFlow;
      }
      if (requestParameters.backchannelApplication !== void 0) {
        queryParameters["backchannel_application"] = requestParameters.backchannelApplication;
      }
      if (requestParameters.defaultRelayState !== void 0) {
        queryParameters["default_relay_state"] = requestParameters.defaultRelayState;
      }
      if (requestParameters.digestAlgorithm !== void 0) {
        queryParameters["digest_algorithm"] = requestParameters.digestAlgorithm;
      }
      if (requestParameters.encryptionKp !== void 0) {
        queryParameters["encryption_kp"] = requestParameters.encryptionKp;
      }
      if (requestParameters.invalidationFlow !== void 0) {
        queryParameters["invalidation_flow"] = requestParameters.invalidationFlow;
      }
      if (requestParameters.isBackchannel !== void 0) {
        queryParameters["is_backchannel"] = requestParameters.isBackchannel;
      }
      if (requestParameters.issuer !== void 0) {
        queryParameters["issuer"] = requestParameters.issuer;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.nameIdMapping !== void 0) {
        queryParameters["name_id_mapping"] = requestParameters.nameIdMapping;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.propertyMappings) {
        queryParameters["property_mappings"] = requestParameters.propertyMappings;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.sessionValidNotOnOrAfter !== void 0) {
        queryParameters["session_valid_not_on_or_after"] = requestParameters.sessionValidNotOnOrAfter;
      }
      if (requestParameters.signAssertion !== void 0) {
        queryParameters["sign_assertion"] = requestParameters.signAssertion;
      }
      if (requestParameters.signResponse !== void 0) {
        queryParameters["sign_response"] = requestParameters.signResponse;
      }
      if (requestParameters.signatureAlgorithm !== void 0) {
        queryParameters["signature_algorithm"] = requestParameters.signatureAlgorithm;
      }
      if (requestParameters.signingKp !== void 0) {
        queryParameters["signing_kp"] = requestParameters.signingKp;
      }
      if (requestParameters.spBinding !== void 0) {
        queryParameters["sp_binding"] = requestParameters.spBinding;
      }
      if (requestParameters.verificationKp !== void 0) {
        queryParameters["verification_kp"] = requestParameters.verificationKp;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/saml/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSAMLProviderListFromJSON(jsonValue));
    });
  }
  /**
   * SAMLProvider Viewset
   */
  providersSamlList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersSamlListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Return metadata as XML string
   */
  providersSamlMetadataRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersSamlMetadataRetrieve.");
      }
      const queryParameters = {};
      if (requestParameters.download !== void 0) {
        queryParameters["download"] = requestParameters.download;
      }
      if (requestParameters.forceBinding !== void 0) {
        queryParameters["force_binding"] = requestParameters.forceBinding;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/saml/{id}/metadata/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLMetadataFromJSON(jsonValue));
    });
  }
  /**
   * Return metadata as XML string
   */
  providersSamlMetadataRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersSamlMetadataRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLProvider Viewset
   */
  providersSamlPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersSamlPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/saml/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedSAMLProviderRequestToJSON(requestParameters.patchedSAMLProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLProviderFromJSON(jsonValue));
    });
  }
  /**
   * SAMLProvider Viewset
   */
  providersSamlPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersSamlPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Preview user data for provider
   */
  providersSamlPreviewUserRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersSamlPreviewUserRetrieve.");
      }
      const queryParameters = {};
      if (requestParameters.forUser !== void 0) {
        queryParameters["for_user"] = requestParameters.forUser;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/saml/{id}/preview_user/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PropertyMappingPreviewFromJSON(jsonValue));
    });
  }
  /**
   * Preview user data for provider
   */
  providersSamlPreviewUserRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersSamlPreviewUserRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLProvider Viewset
   */
  providersSamlRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersSamlRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/saml/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLProviderFromJSON(jsonValue));
    });
  }
  /**
   * SAMLProvider Viewset
   */
  providersSamlRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersSamlRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SAMLProvider Viewset
   */
  providersSamlUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersSamlUpdate.");
      }
      if (requestParameters.sAMLProviderRequest === null || requestParameters.sAMLProviderRequest === void 0) {
        throw new RequiredError("sAMLProviderRequest", "Required parameter requestParameters.sAMLProviderRequest was null or undefined when calling providersSamlUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/saml/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: SAMLProviderRequestToJSON(requestParameters.sAMLProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SAMLProviderFromJSON(jsonValue));
    });
  }
  /**
   * SAMLProvider Viewset
   */
  providersSamlUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersSamlUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersSamlUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersSamlUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/saml/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersSamlUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersSamlUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMProvider Viewset
   */
  providersScimCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.sCIMProviderRequest === null || requestParameters.sCIMProviderRequest === void 0) {
        throw new RequiredError("sCIMProviderRequest", "Required parameter requestParameters.sCIMProviderRequest was null or undefined when calling providersScimCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SCIMProviderRequestToJSON(requestParameters.sCIMProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMProviderFromJSON(jsonValue));
    });
  }
  /**
   * SCIMProvider Viewset
   */
  providersScimCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersScimCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMProvider Viewset
   */
  providersScimDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersScimDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * SCIMProvider Viewset
   */
  providersScimDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersScimDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * SCIMProviderGroup Viewset
   */
  providersScimGroupsCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.sCIMProviderGroupRequest === null || requestParameters.sCIMProviderGroupRequest === void 0) {
        throw new RequiredError("sCIMProviderGroupRequest", "Required parameter requestParameters.sCIMProviderGroupRequest was null or undefined when calling providersScimGroupsCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim_groups/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SCIMProviderGroupRequestToJSON(requestParameters.sCIMProviderGroupRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMProviderGroupFromJSON(jsonValue));
    });
  }
  /**
   * SCIMProviderGroup Viewset
   */
  providersScimGroupsCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersScimGroupsCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMProviderGroup Viewset
   */
  providersScimGroupsDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersScimGroupsDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim_groups/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * SCIMProviderGroup Viewset
   */
  providersScimGroupsDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersScimGroupsDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * SCIMProviderGroup Viewset
   */
  providersScimGroupsListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.groupGroupUuid !== void 0) {
        queryParameters["group__group_uuid"] = requestParameters.groupGroupUuid;
      }
      if (requestParameters.groupName !== void 0) {
        queryParameters["group__name"] = requestParameters.groupName;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.providerId !== void 0) {
        queryParameters["provider__id"] = requestParameters.providerId;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim_groups/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSCIMProviderGroupListFromJSON(jsonValue));
    });
  }
  /**
   * SCIMProviderGroup Viewset
   */
  providersScimGroupsList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersScimGroupsListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMProviderGroup Viewset
   */
  providersScimGroupsRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersScimGroupsRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim_groups/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMProviderGroupFromJSON(jsonValue));
    });
  }
  /**
   * SCIMProviderGroup Viewset
   */
  providersScimGroupsRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersScimGroupsRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersScimGroupsUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersScimGroupsUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim_groups/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersScimGroupsUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersScimGroupsUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMProvider Viewset
   */
  providersScimListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.excludeUsersServiceAccount !== void 0) {
        queryParameters["exclude_users_service_account"] = requestParameters.excludeUsersServiceAccount;
      }
      if (requestParameters.filterGroup !== void 0) {
        queryParameters["filter_group"] = requestParameters.filterGroup;
      }
      if (requestParameters.name !== void 0) {
        queryParameters["name"] = requestParameters.name;
      }
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.url !== void 0) {
        queryParameters["url"] = requestParameters.url;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSCIMProviderListFromJSON(jsonValue));
    });
  }
  /**
   * SCIMProvider Viewset
   */
  providersScimList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersScimListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMProvider Viewset
   */
  providersScimPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersScimPartialUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedSCIMProviderRequestToJSON(requestParameters.patchedSCIMProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMProviderFromJSON(jsonValue));
    });
  }
  /**
   * SCIMProvider Viewset
   */
  providersScimPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersScimPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMProvider Viewset
   */
  providersScimRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersScimRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMProviderFromJSON(jsonValue));
    });
  }
  /**
   * SCIMProvider Viewset
   */
  providersScimRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersScimRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Sync/Re-sync a single user/group object
   */
  providersScimSyncObjectCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersScimSyncObjectCreate.");
      }
      if (requestParameters.syncObjectRequest === null || requestParameters.syncObjectRequest === void 0) {
        throw new RequiredError("syncObjectRequest", "Required parameter requestParameters.syncObjectRequest was null or undefined when calling providersScimSyncObjectCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim/{id}/sync/object/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SyncObjectRequestToJSON(requestParameters.syncObjectRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SyncObjectResultFromJSON(jsonValue));
    });
  }
  /**
   * Sync/Re-sync a single user/group object
   */
  providersScimSyncObjectCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersScimSyncObjectCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get provider\'s sync status
   */
  providersScimSyncStatusRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersScimSyncStatusRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim/{id}/sync/status/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SyncStatusFromJSON(jsonValue));
    });
  }
  /**
   * Get provider\'s sync status
   */
  providersScimSyncStatusRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersScimSyncStatusRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMProvider Viewset
   */
  providersScimUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersScimUpdate.");
      }
      if (requestParameters.sCIMProviderRequest === null || requestParameters.sCIMProviderRequest === void 0) {
        throw new RequiredError("sCIMProviderRequest", "Required parameter requestParameters.sCIMProviderRequest was null or undefined when calling providersScimUpdate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: SCIMProviderRequestToJSON(requestParameters.sCIMProviderRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMProviderFromJSON(jsonValue));
    });
  }
  /**
   * SCIMProvider Viewset
   */
  providersScimUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersScimUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersScimUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersScimUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersScimUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersScimUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMProviderUser Viewset
   */
  providersScimUsersCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.sCIMProviderUserRequest === null || requestParameters.sCIMProviderUserRequest === void 0) {
        throw new RequiredError("sCIMProviderUserRequest", "Required parameter requestParameters.sCIMProviderUserRequest was null or undefined when calling providersScimUsersCreate.");
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim_users/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: SCIMProviderUserRequestToJSON(requestParameters.sCIMProviderUserRequest)
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMProviderUserFromJSON(jsonValue));
    });
  }
  /**
   * SCIMProviderUser Viewset
   */
  providersScimUsersCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersScimUsersCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMProviderUser Viewset
   */
  providersScimUsersDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersScimUsersDestroy.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim_users/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * SCIMProviderUser Viewset
   */
  providersScimUsersDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.providersScimUsersDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * SCIMProviderUser Viewset
   */
  providersScimUsersListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters.ordering !== void 0) {
        queryParameters["ordering"] = requestParameters.ordering;
      }
      if (requestParameters.page !== void 0) {
        queryParameters["page"] = requestParameters.page;
      }
      if (requestParameters.pageSize !== void 0) {
        queryParameters["page_size"] = requestParameters.pageSize;
      }
      if (requestParameters.providerId !== void 0) {
        queryParameters["provider__id"] = requestParameters.providerId;
      }
      if (requestParameters.search !== void 0) {
        queryParameters["search"] = requestParameters.search;
      }
      if (requestParameters.userId !== void 0) {
        queryParameters["user__id"] = requestParameters.userId;
      }
      if (requestParameters.userUsername !== void 0) {
        queryParameters["user__username"] = requestParameters.userUsername;
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim_users/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSCIMProviderUserListFromJSON(jsonValue));
    });
  }
  /**
   * SCIMProviderUser Viewset
   */
  providersScimUsersList(requestParameters = {}, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersScimUsersListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * SCIMProviderUser Viewset
   */
  providersScimUsersRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersScimUsersRetrieve.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim_users/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SCIMProviderUserFromJSON(jsonValue));
    });
  }
  /**
   * SCIMProviderUser Viewset
   */
  providersScimUsersRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersScimUsersRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersScimUsersUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters.id === null || requestParameters.id === void 0) {
        throw new RequiredError("id", "Required parameter requestParameters.id was null or undefined when calling providersScimUsersUsedByList.");
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/providers/scim_users/{id}/used_by/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters.id))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  providersScimUsersUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.providersScimUsersUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
};

export {
  RACProviderFromJSON,
  OAuth2ProviderFromJSON,
  SyncObjectModelEnum,
  ProvidersApi
};
//# sourceMappingURL=chunk-VREDFYGR.js.map
